/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

/**
 * @fileoverview This gadget feature augments gadgets.window with functionality
 * to dynamically set the gadget's secondary title.
 */

var gadgets = gadgets || {};

/* NOTE: no class comment because one already exists in dynamic-height */
gadgets.window = gadgets.window || {};

/**
 * Sets the gadget's secondary title.
 * @param {String} title The preferred secondary title.
 * @member gadgets.window
 */
gadgets.window.setSecondaryTitle = function(title) {
	gadgets.rpc.call(null, "set_secondary_title", null, title);
};
