/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.util.browserSupport");

/**
 * A utility that provides common API for determining whether the 
 * user is using a supported browser.
 */

var support = 2;

if (dojo.isIE <= 7 || dojo.isFF <= 3)
	support = 3;
else if (dojo.isIE >= 8 && dojo.isIE <= 10
		|| dojo.isFF >= 17
		|| dojo.isSafari >= 5.1
		|| dojo.isChrome >= 21)
	support = 1;

jazz.util.browserSupport = {
	
	// Constants
	SUPPORTED: 1,
	TOLERATED: 2,
	NOT_SUPPORTED: 3,
	
	/*
	 * Call to determine whether the browser is supported. Returns one
	 * of the browserSupport constants defined above.
	 */
	getSupportLevel: function () {
		if (this.strictSupport && support == 2)
			return 3;
		return support;
	},
	
	/*
	 * Strict Support Mode
	 * 
	 * Default false, all browsers that do not match either supported or unsupported 
	 * values will return TOLERATED. This is useful for displaying different
	 * levels of messaging to visitors using unclassified browsers, which include
	 * future browser releases or unsupported yet mostly functional browsers.
	 * 
	 * If true, only SUPPORTED or NOT_SUPPORTED will be enabled.
	 */
	strictSupport: false
	
};
})();
