/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	var modules ={}, baseUrl = djConfig.baseUrl;
	baseUrl = baseUrl.substring(0, baseUrl.length - 5);
	
	function resolveDependency(base, id) {
		if (id === 'require')
			return localRequire(base);
		if (id === 'exports')
			return getModule(base, true);
		if (id === 'module')
			return {id:base};
		return getModule(normalize(base, id));
	}
	
	function getModule(id, create) {
		if (!id)
			return null;
		if (!id.indexOf("jazz/inverted!"))
			create = id = id.substring(14);
		var result = modules[id] || modules[id + "/main"];
		if (result)
			return result;
		if (create)
			return modules[id] = {};
		console.error("Unresolved module with id: " + id);
	}
	
	function localRequire(base) {
		function require(required, callback) {
			if (typeof required == 'string' && !callback)
				return modules[normalize(base, required)];
			var i, module, fixed = [];
			for (i = 0; i < required.length; i++) {
				module = normalize(base, required[i]);
				//TODO for now, plain javascript modules use '.' instead of '/'
				if (module.indexOf("!") == -1)
					module = module.replace(/\//g,".");
				fixed[i] = module;
			}
			jazz.core.loader.batch_load_async(fixed, function(){
				var resolved = [];
				for (i = 0; i < required.length;i++)
					resolved[i] = (require(required[i]));
				callback && callback.apply(null, resolved);
			});
		};
		require.on = function ready(unused, callback) {
			callback(); //TODO should this wait until document onload?
		};
		require.toUrl = function toUrl(url) {
			return baseUrl + resolve(base, url);
		};
		require.idle = function (){return true;};
		return require;
	}
	
	function normalize(base, dependency) {
		if (!dependency.indexOf("jazz/css!"))
			return null;
		var i, parts = dependency.split("!");
		for (i = 0; i < parts.length; i++)
			parts[i] = resolve(base, parts[i]);
		dependency = parts.join('!');
		if (!dependency.indexOf("dojo/has!")) {
			var has = modules["dojo/has"];
			dependency = dependency.substring(9);
			dependency = has.normalize(dependency, function(relative){
				return resolve(base, relative);
			});
		} else if (dependency == "dojo/domReady!")
			return;
		return dependency;
	}
	
	function resolve(base, path) {
		if (path.charAt(0) != '.')
			return path;
		if (path.charAt(1) == '.')
			path = base + "/../" + path;
		else
			path = base + "/." + path;
		while (base != path)
			path = (base = path).replace(/\/[^\/]+\/\.\./, "");
		return path;
	}
	
	define = function(id, dependencies, callback) {
		if (!callback)
			return modules[id] = dependencies;
		var i, d, resolved = [];
		for (i = 0; i < dependencies.length; i++) {
			d = resolveDependency(id, dependencies[i]);
			resolved[i] = d;
		}
		modules[id] = callback.apply(null, resolved) || modules[id] || true;
	};
	require = localRequire("");
})();