/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.app.internal.LogoutArea");

dojo.require("net.jazz.ajax.viewletServiceRoot");
dojo.require("jazz.client.xhr");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.util.html");
dojo.require("jazz.app.internal.UserMenu");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.internal.PopupMenuBarItem");

dojo.requireLocalization("jazz.app.internal", "LoginLogoutMessages");

var PlatformUI = net.jazz.ajax.ui.PlatformUI;

dojo.declare("jazz.app.internal.LogoutArea", [jazz.ui.internal.PopupMenuBarItem], {
	allProfilesUrl: "",
	userProfileUrl: "",
	smallPreviewUrl: "",
	personalDashboardUrl: "",
	logoutUrl: "",
	isAdmin: false,
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("jazz.app.internal", "LoginLogoutMessages");
		this.allProfilesUrl = getJtsRoot() + "/admin#action=jazz.viewPage&id=com.ibm.team.repository.users";
	},
	
	createPopup: function() {
		var items = this._getDefaultMenuItems();	
		var args = {
			items: items,
			config: {logout: this.logoutUrl},
			userSmallPreviewUrl: this.smallPreviewUrl
		};
		this.popup = new jazz.app.internal.UserMenu(args);
	},
	_getDefaultMenuItems: function() {
		var items = [{
			label : this.messages.viewMyProfile,
			href : this.userProfileUrl
		}];
		
		if (this.isAdmin)
			items.push({
				label: this.messages.viewOtherProfiles,
				href: this.allProfilesUrl
			});
		items.push({
			label: this.messages.openPersonalDash,
			href: this.personalDashboardUrl
		});
		return items;
	}
});

function getJtsRoot() {
	try {
		var session = dojo.getObject("com.ibm.team.repository.web.client.session");
		if (session) {
			var userUri = session.getAuthenticatedContributorUri();
		}
		if (userUri) {
			var jts = userUri.split("/users/");
			if (jts.length) {
				return jts[0];
			}
		}
	} catch(e) {
		// eat the error
	}
	return net.jazz.ajax.viewletServiceRoot();
}

})();