/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.ui.internal.PopupMenuBarItem");

dojo.require("dijit.Menu");
dojo.require("dijit.MenuBarItem");
dojo.require("jazz.ui.internal.MenuItem");
dojo.require("jazz.ui.internal.PopupMenuItem");
dojo.require("jazz.ui.internal._CssStateMixin");

/**
 * Jazz extension to Dojit's PopupMenuBarItem.
 */
dojo.declare("jazz.ui.internal.PopupMenuBarItem", [jazz.ui.internal.PopupMenuItem, dijit.MenuBarItem._MenuBarItemMixin], {
	
	_setSelected: function(value) {
		if (!this.popup) {
			this.createPopup(this);
			if (this.popup) {
				dojo.body().appendChild(this.popup.domNode);
				this.popup.startup();
				this.popup.domNode.style.display="none";
			}
		}
		this.inherited(arguments);
	},
	
	destroyDescendants: function() {
		if (this.popup.destroyRecursive)
			this.popup.destroyRecursive();
		this.inherited(arguments);
	}
	
});
})();