/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ensemble.internal.adapter.WidgetGadgetUri");

dojo.require("dojo.i18n"); 

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.CheckBox");

dojo.requireLocalization("jazz.ensemble.internal", "WidgetCatalogMessages");

(function() {

/* Constants */
var GADGET_SERVICE = "gadgetAdapter";

dojo.declare("jazz.ensemble.internal.adapter.WidgetGadgetUri", [dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("jazz.ensemble", "internal/adapter/templates/WidgetGadgetUri.html"),
	
	settings: null,
	frontsizeUrl : null,
	viewletEntryId: null, 
	viewletDefinitionId: null,
	
	constructor: function(args) {
		this.msg = dojo.i18n.getLocalization("jazz.ensemble.internal", "WidgetCatalogMessages");

	},
	
	postCreate: function() {
		this._settingsStr = this._serializeSettings();
		
		if(this.frontsizeUrl.substr(this.frontsizeUrl.length - 1) !== "/" ) {
			this.frontsizeUrl += "/";
		}
		
		this._createWidgetUrl();
	},
	
	_serializeSettings: function() {
		if (this.settings) {
			var result = [];
			
			for (var i = 0; i < this.settings.length; i++) {
				var setting = this.settings[i];
				if (!setting.value) continue;
				result.push("&");
				result.push(setting.id);
				result.push("=");
				result.push(setting.value);
			}
			
			return result.join('');
		} 
		return null;
	},
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 */		
	_createWidgetUrl: function() {
		if (!this.frontsizeUrl || (!this.viewletEntryId && !this.viewletDefinitionId)) {
			this._gadgetizedUrlTextArea.value = [this.msg.gadgetUrlError, 
			                                     this.msg.gadgetUrlError_explanation, 
			                                     this.msg.gadgetUrlError_useraction].join(" ");
		} else {
			var result = [];
			result.push(this.frontsizeUrl);
			result.push(GADGET_SERVICE);
			if (this.viewletEntryId) {
				result.push("?viewletEntryId=");
				result.push(this.viewletEntryId);
			} else if (this.viewletDefinitionId) {
				result.push("?viewletDefinitionId=");
				result.push(this.viewletDefinitionId);
			}
			this._settingsStr && result.push(this._settingsStr);
			this._gadgetizedUrlTextArea.value = result.join('');
		}
	},

	destroy: function() {
		this.inherited(arguments);
	}
});
})();