
CREATE TABLE $(CALM_SCHEMA).TIMESHEET_ENTRY (
        TIMESHEET_ENTRY_ID INT NOT NULL,
        TIMESHEET_ID INT DEFAULT -1 NOT NULL,
		ACTIVITY_ID INT DEFAULT -1 NOT NULL,
		TIMESHEET_REPORTING_WEEK DATETIME,
		REFERENCE_ID NVARCHAR(50),
		WORK_DATE DATETIME,
	    DAY_NAME NVARCHAR(60) NOT NULL,
		WORK_TIME INT DEFAULT 0,
		EXTERNAL_ID NVARCHAR(100),
		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 NCHAR(40) DEFAULT '-1' NOT NULL,
		EXTERNAL_KEY3 NCHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID NVARCHAR (36) DEFAULT '-1' NOT NULL,
		URL NVARCHAR(2048),
		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
) ON VNF_32K 
GO

CREATE INDEX TMENTRY_IDX1 ON $(CALM_SCHEMA).TIMESHEET_ENTRY (EXTERNAL_KEY2 ASC)  ON VNF_IDX
GO

CREATE INDEX TMENTRY_IDX2 ON $(CALM_SCHEMA).TIMESHEET_ENTRY (EXTERNAL_KEY3 ASC)  ON VNF_IDX
GO

ALTER TABLE $(CALM_SCHEMA).TIMESHEET_ENTRY ADD CONSTRAINT TMENTRY_PK PRIMARY KEY (TIMESHEET_ENTRY_ID) ON  VNF_IDX
GO

ALTER TABLE $(CALM_SCHEMA).TIMESHEET_ENTRY ADD CONSTRAINT TMENTRY_FK1 FOREIGN KEY (TIMESHEET_ID)
REFERENCES $(NF_SCHEMA).TIMESHEET (TIMESHEET_ID)
GO

ALTER TABLE $(CALM_SCHEMA).TIMESHEET_ENTRY ADD CONSTRAINT TMENTRY_FK2 FOREIGN KEY (ACTIVITY_ID)
REFERENCES $(NF_SCHEMA).ACTIVITY (ACTIVITY_ID)
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=6, CHAR_VALUE='4.0.3' WHERE INFO_ID=16
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=25, CHAR_VALUE='4.0.3 M1' WHERE INFO_ID=17
GO