ALTER SESSION SET CURRENT_SCHEMA= &&CALM_SCHEMA;

CREATE TABLE RQRMENT_DATE_EXT (
		REQUIREMENT_ID INTEGER DEFAULT -1 NOT NULL,
		REQUIREMENT_ATTRDEF_ID INTEGER DEFAULT -1 NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL,
		VAL DATE
) TABLESPACE VNF_32K ;

CREATE INDEX RQRDTEXT_IDX1 ON RQRMENT_DATE_EXT (REQUIREMENT_ID ASC, REQUIREMENT_ATTRDEF_ID ASC) REVERSE TABLESPACE VNF_IDX;

CREATE INDEX RQRDTEXT_IDX2 ON RQRMENT_DATE_EXT (REQUIREMENT_ID ASC, REQUIREMENT_ATTRDEF_ID ASC, VAL ASC) REVERSE TABLESPACE VNF_IDX;

ALTER TABLE RQRMENT_DATE_EXT ADD CONSTRAINT RQRDTEXT_FK1 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES  &&NF_SCHEMA..REQUIREMENT (REQUIREMENT_ID);
	
ALTER TABLE RQRMENT_DATE_EXT ADD CONSTRAINT RQRDTEXT_FK2 FOREIGN KEY (REQUIREMENT_ATTRDEF_ID)
	REFERENCES RQRMENT_ATTRDEF (REQUIREMENT_ATTRDEF_ID);
		
CREATE VIEW VW_RQRMENT_DATE_EXT (REQUIREMENT_ID, NAME, IDENTIFIER, DATATYPE, TYPE_NAME, TYPE_IDENTIFIER, ISSOFTDELETED, VAL) AS
(SELECT E.REQUIREMENT_ID, A.NAME, A.IDENTIFIER, A.DATATYPE, T.NAME AS TYPENAME, T.IDENTIFIER AS TYPE_IDENTIFIER, E.ISSOFTDELETED, E.VAL 
  FROM &&CALM_SCHEMA..RQRMENT_DATE_EXT E 
  JOIN &&CALM_SCHEMA..RQRMENT_ATTRDEF A ON A.REQUIREMENT_ATTRDEF_ID=E.REQUIREMENT_ATTRDEF_ID 
  JOIN &&CALM_SCHEMA..RQRMENT_TYPE T ON T.REQUIREMENT_TYPE_ID=A.REQUIREMENT_TYPE_ID);
  
GRANT SELECT ON &&CALM_SCHEMA..VW_RQRMENT_DATE_EXT TO &&REP_USER;

CREATE TRIGGER TRG_RQRATTRS 
	AFTER UPDATE OF REC_DATETIME ON  &&NF_SCHEMA..REQUIREMENT 
	
	FOR EACH ROW 
BEGIN 
	DELETE FROM RQRMENT_BOOL_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
	DELETE FROM RQRMENT_DATE_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
	DELETE FROM RQRMENT_DECIMAL_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID; 
	DELETE FROM RQRMENT_INT_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
	DELETE FROM RQRMENT_STRING_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
	DELETE FROM RQRMENT_STRING_L_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
	DELETE FROM RQRMENT_TIMESTAMP_EXT WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
END;
/

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=29, CHAR_VALUE='4.0.3 RC1' WHERE INFO_ID=17;