DROP TABLE $(CALM_SCHEMA).TEMP_REQUIREMENT_STG
GO

CREATE TABLE $(CALM_SCHEMA).TEMP_REQUIREMENT_STG (
		ID INTEGER NOT NULL, 
		NAME NVARCHAR(255), 
		EXTERNAL_ID NVARCHAR(100), 
		EXTERNAL_KEY1 NVARCHAR(250), 
		FORMAT NVARCHAR(250), 
		CREATORUUID NVARCHAR(100), 
		CREATION_DATE DATETIME, 
		REC_DATETIME DATETIME, 
		PROJECTUUID NVARCHAR(100), 
		URL NVARCHAR(2048),   
		REQUIREMENT_TYPE NVARCHAR(255), 
		DATATYPE NVARCHAR(255), 
		ISENUMERATION NVARCHAR(250), 
		REQUIREMENT_ATTRDEF_ID NVARCHAR(255), 
		LITERALID NVARCHAR(255), 
		LITERAL_NAME NVARCHAR(255), 
		ATTRNAME NVARCHAR(255), 
		VAL NVARCHAR(255),  
		VAL_TIME DATETIME,  
		ATTRTYPENAME NVARCHAR(255), 
		REQUIREMENT_TYPE_ID NVARCHAR(255),  
		REQUIREMENTUUID NVARCHAR(100), 
		PROJECTAREAUUID NVARCHAR(100), 
		ISDELETED NVARCHAR(250), 
		ISMULTIVALUED NVARCHAR(250), 
		DATASOURCE_ID NVARCHAR(36)
) ON VNF_32K 
GO

DROP TABLE $(CALM_SCHEMA).TEMP_REQUIREMENT_LINK_STG
GO

CREATE TABLE $(CALM_SCHEMA).TEMP_REQUIREMENT_LINK_STG (
		ID INTEGER NOT NULL, 
		EXTERNAL_ID NVARCHAR(100), 
		FORMAT NVARCHAR(250), 
		IMPLEMENTEDBY NVARCHAR(100), 
		IMPLEMENTEDBYURL NVARCHAR(2048), 
		VALIDATEDBY NVARCHAR(100), 
		EXTERNAL_UUID NVARCHAR(100), 
		EXTERNAL_URL NVARCHAR(2048), 
		EXTERNAL_LABEL NVARCHAR(255), 
		EXTERNALLINKTYPE NVARCHAR(100), 
		LINKRELATION NVARCHAR(100), 
		LINKRELATIONURL NVARCHAR(2048), 
		AFFECTEDBY NVARCHAR(100), 
		TRACKEDBY NVARCHAR(100), 
		LINKTITLE NVARCHAR(255), 
		LINKTYPEUUID NVARCHAR(100), 
		LINKTYPENAME NVARCHAR(255), 
		ISPARENTLINK NVARCHAR(250), 
		ISCHILDLINK NVARCHAR(250), 
		MODULEARTIFACTUUID NVARCHAR(100), 
		MODULEUUID NVARCHAR(100), 
		DATASOURCE_ID NVARCHAR(36)
) ON VNF_32K 
GO

CREATE TABLE $(CALM_SCHEMA).TEMP_REQUIREMENT_PTEXT_STG (
	EXTERNAL_ID NVARCHAR(100) NOT NULL,
	PTEXT NVARCHAR(4000) NOT NULL
) ON VNF_32K 
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=31, CHAR_VALUE='4.0.5 S2' WHERE INFO_ID=17
GO