SET CURRENT SCHEMA CONFIG;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 17 AS INFO_ID,'CALM_MINOR_VERSION' AS NAME,'CALM Warehouse Minor Version' AS DISPLAY_NAME,4 AS INT_VALUE,'4.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=17);

SET CURRENT SCHEMA RICALM;

CREATE TABLE EXECWORKITEM_STRING_EXT (
		EXECWORKITEM_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE EXECWORKITEM_STRING_M_EXT (
		EXECWORKITEM_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR VARCHAR(1024),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE EXECWORKITEM_INT_EXT (
		EXECWORKITEM_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR INTEGER,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE EXECWORKITEM_TIMESTAMP_EXT (
		EXECWORKITEM_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR TIMESTAMP,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE TSTSUITEXECREC_STRING_EXT (
		TESTSUITE_EXECRECORD_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE TSTSUITEXECREC_STRING_M_EXT (
		TESTSUITE_EXECRECORD_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR VARCHAR(1024),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE TSTSUITEXECREC_INT_EXT (
		TESTSUITE_EXECRECORD_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR INTEGER,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE TABLE TSTSUITEXECREC_TIMESTAMP_EXT (
		TESTSUITE_EXECRECORD_ID INTEGER DEFAULT -1 NOT NULL,
		IDENTIFIER VARCHAR(255) DEFAULT '-1' NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Custom Attribute Name Missing' NOT NULL,
		VAR TIMESTAMP,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
);

CREATE INDEX EWISTREXT_IDX1 ON EXECWORKITEM_STRING_EXT (EXECWORKITEM_ID ASC, NAME ASC);
CREATE INDEX EWISTREXT_IDX2 ON EXECWORKITEM_STRING_EXT (ISSOFTDELETED ASC);

CREATE INDEX EWISTRMEXT_IDX1 ON EXECWORKITEM_STRING_M_EXT (EXECWORKITEM_ID ASC, NAME ASC);
CREATE INDEX EWISTRMEXT_IDX2 ON EXECWORKITEM_STRING_M_EXT (ISSOFTDELETED ASC);

CREATE INDEX EWIINTEXT_IDX1 ON EXECWORKITEM_INT_EXT (EXECWORKITEM_ID ASC, NAME ASC);
CREATE INDEX EWIINTEXT_IDX2 ON EXECWORKITEM_INT_EXT (ISSOFTDELETED ASC);

CREATE INDEX EWITIMEEXT_IDX1 ON EXECWORKITEM_TIMESTAMP_EXT (EXECWORKITEM_ID ASC, NAME ASC);
CREATE INDEX EWITIMEEXT_IDX2 ON EXECWORKITEM_TIMESTAMP_EXT (ISSOFTDELETED ASC);

CREATE INDEX TSERSTREXT_IDX1 ON TSTSUITEXECREC_STRING_EXT (TESTSUITE_EXECRECORD_ID ASC, NAME ASC);
CREATE INDEX TSERSTREXT_IDX2 ON TSTSUITEXECREC_STRING_EXT (ISSOFTDELETED ASC);

CREATE INDEX TSERSTRMEXT_IDX1 ON TSTSUITEXECREC_STRING_M_EXT (TESTSUITE_EXECRECORD_ID ASC, NAME ASC);
CREATE INDEX TSERSTRMEXT_IDX2 ON TSTSUITEXECREC_STRING_M_EXT (ISSOFTDELETED ASC);

CREATE INDEX TSERINTEXT_IDX1 ON TSTSUITEXECREC_INT_EXT (TESTSUITE_EXECRECORD_ID ASC, NAME ASC);
CREATE INDEX TSERINTEXT_IDX2 ON TSTSUITEXECREC_INT_EXT (ISSOFTDELETED ASC);

CREATE INDEX TSERTIMEEXT_IDX1 ON TSTSUITEXECREC_TIMESTAMP_EXT (TESTSUITE_EXECRECORD_ID ASC, NAME ASC);
CREATE INDEX TSERTIMEEXT_IDX2 ON TSTSUITEXECREC_TIMESTAMP_EXT (ISSOFTDELETED ASC);

ALTER TABLE EXECWORKITEM_STRING_EXT ADD CONSTRAINT EWISTREXT_PK PRIMARY KEY (EXECWORKITEM_ID, IDENTIFIER);

ALTER TABLE EXECWORKITEM_STRING_M_EXT ADD CONSTRAINT EWISTRMEXT_PK PRIMARY KEY (EXECWORKITEM_ID, IDENTIFIER);

ALTER TABLE EXECWORKITEM_INT_EXT ADD CONSTRAINT EWIINTEXT_PK PRIMARY KEY (EXECWORKITEM_ID, IDENTIFIER);

ALTER TABLE EXECWORKITEM_TIMESTAMP_EXT ADD CONSTRAINT EWITIMEEXT_PK PRIMARY KEY (EXECWORKITEM_ID, IDENTIFIER);

ALTER TABLE TSTSUITEXECREC_STRING_EXT ADD CONSTRAINT TSERSTREXT_PK PRIMARY KEY (TESTSUITE_EXECRECORD_ID, IDENTIFIER);

ALTER TABLE TSTSUITEXECREC_STRING_M_EXT ADD CONSTRAINT TSERSTRMEXT_PK PRIMARY KEY (TESTSUITE_EXECRECORD_ID, IDENTIFIER);

ALTER TABLE TSTSUITEXECREC_INT_EXT ADD CONSTRAINT TSERINTEXT_PK PRIMARY KEY (TESTSUITE_EXECRECORD_ID, IDENTIFIER);

ALTER TABLE TSTSUITEXECREC_TIMESTAMP_EXT ADD CONSTRAINT TSERTIMEEXT_PK PRIMARY KEY (TESTSUITE_EXECRECORD_ID, IDENTIFIER);

ALTER TABLE EXECWORKITEM_STRING_EXT ADD CONSTRAINT EWISTREXT_FK1 FOREIGN KEY (EXECWORKITEM_ID)
REFERENCES RIODS.EXECUTION_WORKITEM (EXECWORKITEM_ID) ON DELETE CASCADE;
	
ALTER TABLE EXECWORKITEM_STRING_M_EXT ADD CONSTRAINT EWISTRMEXT_FK1 FOREIGN KEY (EXECWORKITEM_ID)
REFERENCES RIODS.EXECUTION_WORKITEM (EXECWORKITEM_ID) ON DELETE CASCADE;
	
ALTER TABLE EXECWORKITEM_INT_EXT ADD CONSTRAINT EWIINTEXT_FK1 FOREIGN KEY (EXECWORKITEM_ID)
REFERENCES RIODS.EXECUTION_WORKITEM (EXECWORKITEM_ID) ON DELETE CASCADE;
	
ALTER TABLE EXECWORKITEM_TIMESTAMP_EXT ADD CONSTRAINT EWITIMEEXT_FK1 FOREIGN KEY (EXECWORKITEM_ID)
REFERENCES RIODS.EXECUTION_WORKITEM (EXECWORKITEM_ID) ON DELETE CASCADE;
	
ALTER TABLE TSTSUITEXECREC_STRING_EXT ADD CONSTRAINT TSERSTREXT_FK1 FOREIGN KEY (TESTSUITE_EXECRECORD_ID)
REFERENCES RIODS.TESTSUITE_EXECUTION_RECORD (TESTSUITE_EXECRECORD_ID) ON DELETE CASCADE;
	
ALTER TABLE TSTSUITEXECREC_STRING_M_EXT ADD CONSTRAINT TSERSTRMEXT_FK1 FOREIGN KEY (TESTSUITE_EXECRECORD_ID)
REFERENCES RIODS.TESTSUITE_EXECUTION_RECORD (TESTSUITE_EXECRECORD_ID) ON DELETE CASCADE;
	
ALTER TABLE TSTSUITEXECREC_INT_EXT ADD CONSTRAINT TSERINTEXT_FK1 FOREIGN KEY (TESTSUITE_EXECRECORD_ID)
REFERENCES RIODS.TESTSUITE_EXECUTION_RECORD (TESTSUITE_EXECRECORD_ID) ON DELETE CASCADE;
	
ALTER TABLE TSTSUITEXECREC_TIMESTAMP_EXT ADD CONSTRAINT TSERTIMEEXT_FK1 FOREIGN KEY (TESTSUITE_EXECRECORD_ID)
REFERENCES RIODS.TESTSUITE_EXECUTION_RECORD (TESTSUITE_EXECRECORD_ID) ON DELETE CASCADE;
	
CREATE TRIGGER TRG_EWISTREXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.EXECUTION_WORKITEM
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE EXECWORKITEM_STRING_EXT SET ISSOFTDELETED=1 WHERE EXECWORKITEM_ID=NEWROW.EXECWORKITEM_ID;
	
CREATE TRIGGER TRG_EWISTRMEXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.EXECUTION_WORKITEM
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE EXECWORKITEM_STRING_M_EXT SET ISSOFTDELETED=1 WHERE EXECWORKITEM_ID=NEWROW.EXECWORKITEM_ID;
	
CREATE TRIGGER TRG_EWIINTEXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.EXECUTION_WORKITEM
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE EXECWORKITEM_INT_EXT SET ISSOFTDELETED=1 WHERE EXECWORKITEM_ID=NEWROW.EXECWORKITEM_ID;
	
CREATE TRIGGER TRG_EWITIMEEXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.EXECUTION_WORKITEM
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE EXECWORKITEM_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE EXECWORKITEM_ID=NEWROW.EXECWORKITEM_ID;
    
CREATE TRIGGER TRG_TSERSTREXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITE_EXECUTION_RECORD
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL 
    UPDATE TSTSUITEXECREC_STRING_EXT SET ISSOFTDELETED=1 WHERE TESTSUITE_EXECRECORD_ID=NEWROW.TESTSUITE_EXECRECORD_ID;
	
CREATE TRIGGER TRG_TSERSTRMEXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITE_EXECUTION_RECORD
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE TSTSUITEXECREC_STRING_M_EXT SET ISSOFTDELETED=1 WHERE TESTSUITE_EXECRECORD_ID=NEWROW.TESTSUITE_EXECRECORD_ID;
	
CREATE TRIGGER TRG_TSERINTEXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITE_EXECUTION_RECORD
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE TSTSUITEXECREC_INT_EXT SET ISSOFTDELETED=1 WHERE TESTSUITE_EXECRECORD_ID=NEWROW.TESTSUITE_EXECRECORD_ID;
	
CREATE TRIGGER TRG_TSERTIMEEXTD
	AFTER UPDATE OF REC_DATETIME ON RIODS.TESTSUITE_EXECUTION_RECORD
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
    UPDATE TSTSUITEXECREC_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE TESTSUITE_EXECRECORD_ID=NEWROW.TESTSUITE_EXECRECORD_ID;
	
CREATE VIEW VW_EXECWORKITEM_STRING_EXT (EXECWORKITEM_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT EWI.EXECWORKITEM_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.EXECWORKITEM_STRING_EXT E
  JOIN RIODS.EXECUTION_WORKITEM EWI ON EWI.EXECWORKITEM_ID=E.EXECWORKITEM_ID);

CREATE VIEW VW_EXECWORKITEM_STRING_M_EXT (EXECWORKITEM_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT EWI.EXECWORKITEM_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.EXECWORKITEM_STRING_M_EXT E
  JOIN RIODS.EXECUTION_WORKITEM EWI ON EWI.EXECWORKITEM_ID=E.EXECWORKITEM_ID);
  
CREATE VIEW VW_EXECWORKITEM_INT_EXT (EXECWORKITEM_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT EWI.EXECWORKITEM_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.EXECWORKITEM_INT_EXT E
  JOIN RIODS.EXECUTION_WORKITEM EWI ON EWI.EXECWORKITEM_ID=E.EXECWORKITEM_ID);
  
CREATE VIEW VW_EXECWORKITEM_TIMESTAMP_EXT (EXECWORKITEM_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT EWI.EXECWORKITEM_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.EXECWORKITEM_TIMESTAMP_EXT E
  JOIN RIODS.EXECUTION_WORKITEM EWI ON EWI.EXECWORKITEM_ID=E.EXECWORKITEM_ID);
  
CREATE VIEW VW_TSTSUITEXECREC_STRING_EXT (TESTSUITE_EXECRECORD_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT T.TESTSUITE_EXECRECORD_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.TSTSUITEXECREC_STRING_EXT E
  JOIN RIODS.TESTSUITE_EXECUTION_RECORD T ON T.TESTSUITE_EXECRECORD_ID=E.TESTSUITE_EXECRECORD_ID);
  
CREATE VIEW VW_TSTSUITEXECREC_STRING_M_EXT (TESTSUITE_EXECRECORD_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT T.TESTSUITE_EXECRECORD_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.TSTSUITEXECREC_STRING_M_EXT E
  JOIN RIODS.TESTSUITE_EXECUTION_RECORD T ON T.TESTSUITE_EXECRECORD_ID=E.TESTSUITE_EXECRECORD_ID);
  
CREATE VIEW VW_TSTSUITEXECREC_INT_EXT (TESTSUITE_EXECRECORD_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT T.TESTSUITE_EXECRECORD_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.TSTSUITEXECREC_INT_EXT E
  JOIN RIODS.TESTSUITE_EXECUTION_RECORD T ON T.TESTSUITE_EXECRECORD_ID=E.TESTSUITE_EXECRECORD_ID);
  
CREATE VIEW VW_TSTSUITEXCREC_TIMESTAMP_EXT (TESTSUITE_EXECRECORD_ID, IDENTIFIER, NAME, VAR, ISSOFTDELETED) AS
(SELECT T.TESTSUITE_EXECRECORD_ID, E.IDENTIFIER, E.NAME, E.VAR, E.ISSOFTDELETED
  FROM RICALM.TSTSUITEXECREC_TIMESTAMP_EXT E
  JOIN RIODS.TESTSUITE_EXECUTION_RECORD T ON T.TESTSUITE_EXECRECORD_ID=E.TESTSUITE_EXECRECORD_ID);
  
GRANT SELECT ON RICALM.VW_EXECWORKITEM_STRING_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_EXECWORKITEM_STRING_M_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_EXECWORKITEM_INT_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_EXECWORKITEM_TIMESTAMP_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_TSTSUITEXECREC_STRING_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_TSTSUITEXECREC_STRING_M_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_TSTSUITEXECREC_INT_EXT TO REPUSER;
GRANT SELECT ON RICALM.VW_TSTSUITEXCREC_TIMESTAMP_EXT TO REPUSER;

ALTER TABLE RICALM.REQUEST_HISTORY ADD CREATOR_ID INTEGER DEFAULT -1 NOT NULL;
ALTER TABLE RICALM.REQUEST_HISTORY ADD DUE_DATE TIMESTAMP;

ALTER TABLE REQUEST_HISTORY ADD CONSTRAINT REQHIS_FK22 FOREIGN KEY (CREATOR_ID)
	REFERENCES RIODS.RESOURCE (RESOURCE_ID);
	
DROP VIEW RICALM.VW_RQST_HISTORY;

CREATE VIEW VW_RQST_HISTORY (ACTIVATE_DATE, ASSIGNED_DATE, CLOSED_DATE, COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DUPLICATE_DATE, EXTERNAL_ID, FIXEDINRELEASE_ID, FIXED_IN_RELEASE_NAME, IS_BLOCKING, ITERATION_ID, ITERATION_NAME, TEAM_ID, TEAM_NAME, PLANNED_WORK, ACTUAL_WORK, COMMENT_COUNT, SUBSCRIBER_COUNT, STORY_POINTS, TAGS, NAME, PLATFORM, REQUEST_PRIORITY_ID, REQUEST_PRIORITY, REQUEST_PRIORITY_EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, FOUND_IN_RELEASE_NAME, REQUEST_CLASS_ID, REQUEST_CLASS, REQUEST_HISTORY_ID, OWNER_ID, REQUEST_RESPONSIBLE, REQUEST_SOURCE, REQUEST_STATE_ID, REQUEST_STATE, REQUEST_STATE_EXTERNAL_ID, REQUEST_RESOLUTION_ID, REQUEST_RESOLUTION, REQUEST_RESOLUTION_EXTERNAL_ID, RESOLVED_DATE, REQUEST_SEVERITY_ID, REQUEST_SEVERITY, REQUEST_SEVERITY_EXTERNAL_ID, SLOC_CHANGE, REQUEST_STATUS_ID, REQUEST_STATUS, REQUEST_STATUS_EXTERNAL_ID, SUBMIT_DATE, URL, 
DUE_DATE, CREATOR_ID, CREATOR_NAME, BUILD_ID, BUILD_NAME, PHASE_ID, PHASE_NAME, PROJECT_CATEGORY_ID, PROJECT_CATEGORY_NAME, EXTERNAL_KEY1, EXTERNAL_KEY2, REQUEST_TYPE_ID, REQUEST_TYPE, REQUEST_TYPE_EXTERNAL_ID, REQUEST_CATEGORY_ID, REQUEST_CATEGORY_NAME, RESOLVER_ID, RESOLVER_NAME, SUMMARY, REC_DATETIME, ISSOFTDELETED, PREV_REQUEST_HISTORY_ID) AS
 (SELECT R.ACTIVATE_DATE, R.ASSIGNED_DATE, R.CLOSED_DATE, R.COMPONENT_ID, C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DUPLICATE_DATE, R.EXTERNAL_ID, R.FIXEDINRELEASE_ID, RL.NAME AS FIXED_IN_RELEASE_NAME, R.IS_BLOCKING, R.ITERATION_ID, I.NAME AS ITERATION_NAME, R.TEAM_ID, T.NAME AS TEAM_NAME, R.PLANNED_WORK, R.ACTUAL_WORK, R.COMMENT_COUNT, R.SUBSCRIBER_COUNT, R.STORY_POINTS, R.TAGS, R.NAME, R.PLATFORM, R.REQUEST_PRIORITY_ID, RP.NAME AS REQUEST_PRIORITY, RP.EXTERNAL_ID AS REQUEST_PRIORITY_EXTERNAL_ID, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME, R.REFERENCE_ID, R.RELEASE_ID, RL2.NAME AS FOUND_IN_RELEASE_NAME, 
 R.REQUEST_CLASS_ID, RQ.NAME AS REQUEST_CLASS, R.REQUEST_HISTORY_ID, R.OWNER_ID, PS.FULL_NAME AS REQUEST_RESPONSIBLE, R.REQUEST_SOURCE, R.REQUEST_STATE_ID, RST.NAME AS REQUEST_STATE, RST.EXTERNAL_ID AS REQUEST_STATE_EXTERNAL_ID, R.REQUEST_RESOLUTION_ID, RRES.NAME AS REQUEST_RESOLUTION, RRES.EXTERNAL_ID AS REQUEST_RESOLUTION_EXTERNAL_ID, R.RESOLVED_DATE, R.REQUEST_SEVERITY_ID, RSEV.NAME AS REQUEST_SEVERITY, RSEV.EXTERNAL_ID AS REQUEST_SEVERITY_EXTERNAL_ID, R.SLOC_CHANGE, R.REQUEST_STATUS_ID, RSTU.NAME AS REQUEST_STATUS, RSTU.EXTERNAL_ID AS  REQUEST_STATUS_EXTERNAL_ID, R.SUBMIT_DATE, R.URL, 
 R.DUE_DATE, R.CREATOR_ID, RES.FULL_NAME AS CREATOR_NAME, R.BUILD_ID, B.NAME AS BUILD_NAME, R.PHASE_ID, PH.NAME AS PHASE_NAME, R.PROJECT_CATEGORY_ID, PC.NAME AS PROJECT_CATEGORY_NAME, R.EXTERNAL_KEY1, R.EXTERNAL_KEY2, R.REQUEST_TYPE_ID, RT.NAME REQUEST_TYPE, RT.EXTERNAL_ID AS REQUEST_TYPE_EXTERNAL_ID, R.REQUEST_CATEGORY_ID, RC.NAME AS REQUEST_CATEGORY_NAME, R.RESOLVER_ID, RS.FULL_NAME AS RESOLVER_NAME, R.SUMMARY, R.REC_DATETIME, R.ISSOFTDELETED, R.PREV_REQUEST_HISTORY_ID
  FROM RICALM.REQUEST_HISTORY R 
  JOIN RIODS.ITERATION I ON I.ITERATION_ID=R.ITERATION_ID 
  JOIN RIODS.TEAM T ON T.TEAM_ID=R.TEAM_ID
  JOIN RIODS.PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID 
  JOIN RIODS.COMPONENT C ON C.COMPONENT_ID=R.COMPONENT_ID 
  JOIN RIODS.RELEASE RL ON RL.RELEASE_ID=R.FIXEDINRELEASE_ID 
  JOIN RIODS.RELEASE RL2 ON RL2.RELEASE_ID=R.RELEASE_ID 
  JOIN RIODS.REQUEST_CLASSIFICATION RQ ON RQ.REQUEST_CLASS_ID=R.REQUEST_CLASS_ID
  JOIN RIODS.REQUEST_CATEGORY RC ON RC.REQUEST_CATEGORY_ID=R.REQUEST_CATEGORY_ID
  JOIN RIODS.BUILD B ON B.BUILD_ID=R.BUILD_ID
  JOIN RIODS.PHASE PH ON PH.PHASE_ID=R.PHASE_ID
  JOIN RIODS.PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=R.PROJECT_CATEGORY_ID
  JOIN RIODS.RESOURCE PS ON PS.RESOURCE_ID=R.OWNER_ID
  JOIN RIODS.RESOURCE RS ON RS.RESOURCE_ID=R.RESOLVER_ID
  JOIN RIODS.RESOURCE RES ON RES.RESOURCE_ID=R.CREATOR_ID
  JOIN RIODS.REQUEST_STATE RST ON RST.REQUEST_STATE_ID=R.REQUEST_STATE_ID
  JOIN RIODS.REQUEST_STATUS RSTU ON RSTU.REQUEST_STATUS_ID=R.REQUEST_STATUS_ID
  JOIN RIODS.REQUEST_PRIORITY RP ON RP.REQUEST_PRIORITY_ID=R.REQUEST_PRIORITY_ID
  JOIN RIODS.REQUEST_RESOLUTION RRES ON RRES.REQUEST_RESOLUTION_ID=R.REQUEST_RESOLUTION_ID
  JOIN RIODS.REQUEST_SEVERITY RSEV ON RSEV.REQUEST_SEVERITY_ID=R.REQUEST_SEVERITY_ID
  JOIN RIODS.REQUEST_TYPE RT ON RT.REQUEST_TYPE_ID=R.REQUEST_TYPE_ID);
  
GRANT SELECT ON RICALM.VW_RQST_HISTORY TO REPUSER;

UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=5, CHAR_VALUE='4.0 M7' WHERE INFO_ID=17;
