CREATE INDEX REQREV_IDX8 ON $(NF_SCHEMA).REQUIREMENT_REVISION_HISTORY (REQUIREMENT_ID,REVISION_NUMBER,SOURCE_ID)  ON VNF_IDX
GO

DROP TRIGGER $(NF_SCHEMA).TRG_REQREQ
GO
CREATE TRIGGER TRG_REQREQ
    ON $(NF_SCHEMA).REQUEST

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN

  DELETE FROM $(NF_SCHEMA).REQUEST_HIERARCHY  WHERE  PARENT_REQUEST_ID IN
	(SELECT  REQUEST_ID FROM INSERTED ) OR CHILD_REQUEST_ID IN (SELECT REQUEST_ID FROM INSERTED )
 END
GO

DROP TRIGGER $(NF_SCHEMA).TRG_PRJBSLND
GO
CREATE TRIGGER TRG_PRJBSLND
    ON $(NF_SCHEMA).PROJECT_BASELINE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN

  DELETE FROM $(NF_SCHEMA).PROJ_BASELINE_BASELINE_LOOKUP  WHERE  BASELINE_ID IN
    (SELECT  BASELINE_ID FROM INSERTED ) OR COMPBASELINE_ID IN (SELECT BASELINE_ID FROM INSERTED)
 END
GO

DROP TRIGGER $(NF_SCHEMA).TRG_REQIREQUID
GO
CREATE TRIGGER TRG_REQIREQUID
    ON $(NF_SCHEMA).REQUIREMENT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN

  DELETE FROM $(NF_SCHEMA).REQUIREMENT_REQUIREMENT_LOOKUP  WHERE  REQUIREMENT_ID IN
  (SELECT  REQUIREMENT_ID FROM INSERTED ) OR CREQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
 END
GO

DROP TRIGGER $(NF_SCHEMA).TRG_PRJHIERD
GO
CREATE TRIGGER TRG_PRJHIERD
    ON $(NF_SCHEMA).PROJECT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN

  DELETE FROM $(NF_SCHEMA).PROJECT_HIERARCHY  WHERE  PARENT_PROJECT_ID IN
   (SELECT  PROJECT_ID FROM INSERTED ) OR CHILD_PROJECT_ID IN (SELECT PROJECT_ID FROM INSERTED )
 END
GO

DROP TRIGGER $(NF_SCHEMA).TRG_REQHIER
GO
CREATE TRIGGER TRG_REQHIER
    ON $(NF_SCHEMA).REQUIREMENT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN

  DELETE FROM $(NF_SCHEMA).REQUIREMENT_HIERARCHY  WHERE  PRED_REQUIREMENT_ID IN
 (SELECT  REQUIREMENT_ID FROM INSERTED ) OR SUCC_REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED )
 END
GO

CREATE TRIGGER TRG_TPTPHIER
	ON $(NF_SCHEMA).TESTPLAN

	FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN

	DELETE FROM $(NF_SCHEMA).TESTPLAN_TESTPLAN_HIERARCHY
	WHERE PARENT_TESTPLAN_ID IN (SELECT TESTPLAN_ID FROM INSERTED) OR CHILD_TESTPLAN_ID IN (SELECT TESTPLAN_ID FROM INSERTED)
 END
GO

INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (9,'DATA_TRUNCATION','Interpreted as do not compute or delete data with dates earlier or equal to the value set',1,'1899-12-31')
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=8, CHAR_VALUE='2.0.1 RC2' WHERE INFO_ID=18
GO