ALTER SESSION SET CURRENT_SCHEMA= &&CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0.3' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=7;

MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE) VALUES(8,'MIGRATION_STATUS','Insight Warehouse Migration Status',0);
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,9 AS INT_VALUE,'2.0.3 RC2' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (18,'MINOR_VERSION','Insight Warehouse Minor Version',9,'2.0.3 RC2');
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (9,'DATA_TRUNCATION','Interpreted as do not compute or delete data with dates earlier or equal to the value set',1,'1899-12-31');


DROP TRIGGER &&NF_SCHEMA.TRG_REQHIER;
CREATE TRIGGER &&NF_SCHEMA.TRG_REQHIER
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.REQUIREMENT

	FOR EACH ROW
BEGIN
		DELETE FROM &&NF_SCHEMA.REQUIREMENT_HIERARCHY WHERE PRED_REQUIREMENT_ID=:NEW.REQUIREMENT_ID AND EXISTS (SELECT REQUIREMENT_CLASS_ID FROM &&NF_SCHEMA.REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement') AND REQUIREMENT_CLASS_ID=:NEW.REQUIREMENT_CLASS_ID);
END;
/


CREATE TRIGGER &&NF_SCHEMA.TRG_REQHIER2
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.REQUIREMENT

	FOR EACH ROW
BEGIN
    	DELETE FROM &&NF_SCHEMA.REQUIREMENT_HIERARCHY WHERE PRED_REQUIREMENT_ID=:NEW.REQUIREMENT_ID OR SUCC_REQUIREMENT_ID=:NEW.REQUIREMENT_ID AND NOT EXISTS (SELECT REQUIREMENT_CLASS_ID FROM &&NF_SCHEMA.REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement') AND REQUIREMENT_CLASS_ID=:NEW.REQUIREMENT_CLASS_ID);
END;
/

INSERT INTO &&NF_SCHEMA.TIMESHEET (TIMESHEET_ID, REFERENCE_ID) VALUES (-1, 'Info Not Available');

DROP VIEW &&STAR_SCHEMA.VW_TESTSUITELOG;
CREATE VIEW &&STAR_SCHEMA.VW_TESTSUITELOG (BUILD_ID, TESTSUITELOG_NAME,END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, TESTSUITELOG_ID, TESTSUITE_ID, TESTSUITE_NAME, URL, VERDICT,OWNER_ID, OWNER_NAME,TESTPLAN_ID,TESTPLAN_NAME,WEIGHT,POINTS_PASSED,POINTS_FAILED,POINTS_BLOCKED,POINTS_INCONCLUSIVE,POINTS_ATTEMPTED,POINTS_PERMFAILED,POINTS_DEFERRED,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITELOG_CLASS_ID,TESTSUITELOG_CLASS_NAME,TESTSUITE_EXECRECORD_ID,TESTSUITE_EXECRECORD_NAME,REC_DATETIME,ISSOFTDELETED,
TESTSUITELOG_STATE,TESTSUITELOG_STATE_ID,TESTSUITELOG_STATE_EXTERNAL_ID,TESTSUITELG_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,TOTAL_TESTCASE_COUNT,NOTSTARTED_TESTCASE_COUNT) AS
 (SELECT S.BUILD_ID, S.NAME AS TESTSUITELOG_NAME, S.END_DATE, S.EXTERNAL_ID, S.ITERATION_ID,I.NAME AS ITERATION_NAME, S.REFERENCE_ID, S.START_DATE, S.TESTSUITELOG_ID, S.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, S.URL, S.VERDICT,S.OWNER_ID,R.FULL_NAME AS  OWNER_NAME ,S.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,S.WEIGHT,S.POINTS_PASSED,S.POINTS_FAILED,S.POINTS_BLOCKED,S.POINTS_INCONCLUSIVE,S.POINTS_ATTEMPTED,S.POINTS_PERMFAILED,S.POINTS_DEFERRED,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.TESTSUITELOG_CLASS_ID,TL.NAME AS TESTSUITELOG_CLASS_NAME,S.TESTSUITE_EXECRECORD_ID,TEX.NAME AS TESTSUITE_EXECRECORD_NAME,S.REC_DATETIME,S.ISSOFTDELETED,
 TS.NAME AS TESTSUITELOG_STATE,S.TESTSUITELOG_STATE_ID,TS.EXTERNAL_ID AS TESTSUITELOG_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITELG_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,S.TOTAL_TESTCASE_COUNT,S.NOTSTARTED_TESTCASE_COUNT
 FROM &&NF_SCHEMA.TESTSUITELOG S
 JOIN &&NF_SCHEMA.ITERATION I ON I.ITERATION_ID=S.ITERATION_ID
 JOIN &&NF_SCHEMA.TESTSUITE T ON T.TESTSUITE_ID=S.TESTSUITE_ID
 JOIN &&NF_SCHEMA."RESOURCE" R ON R.RESOURCE_ID=S.OWNER_ID
 JOIN &&NF_SCHEMA.TESTSUITELOG_CLASSIFICATION TL ON TL.TESTSUITELOG_CLASS_ID=S.TESTSUITELOG_CLASS_ID
 JOIN &&NF_SCHEMA.TESTPLAN TP ON TP.TESTPLAN_ID=S.TESTPLAN_ID
 JOIN &&NF_SCHEMA.TESTSUITE_EXECUTION_RECORD TEX ON TEX.TESTSUITE_EXECRECORD_ID=S.TESTSUITE_EXECRECORD_ID
 JOIN &&NF_SCHEMA.TESTSUITELOG_STATE TS ON TS.TESTSUITELOG_STATE_ID=S.TESTSUITELOG_STATE_ID
JOIN &&NF_SCHEMA.TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID);
GRANT SELECT ON &&STAR_SCHEMA.VW_TESTSUITELOG TO REPUSER;

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=6;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.3 RC2',INT_VALUE=9 WHERE INFO_ID=18;