INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=6)
GO
INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=7)
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=7
GO

IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=8) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MIGRATION_STATUS',DISPLAY_NAME='Insight Warehouse Migration Status',INT_VALUE=0,CHAR_VALUE='' WHERE INFO_ID=8
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=18) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,9 AS INT_VALUE,'2.0.3 RC2' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MINOR_VERSION',DISPLAY_NAME='Insight Warehouse Minor Version',INT_VALUE=9,CHAR_VALUE='2.0.3 RC2' WHERE INFO_ID=18
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=9) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='DATA_TRUNCATION',DISPLAY_NAME='Interpreted as do not compute or delete data with dates earlier or equal to the value set' ,INT_VALUE=1 WHERE INFO_ID=9
GO


DROP TRIGGER $(NF_SCHEMA).TRG_REQHIER
GO

CREATE TRIGGER TRG_REQHIER
	ON $(NF_SCHEMA).REQUIREMENT

	FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
	DELETE FROM $(NF_SCHEMA).REQUIREMENT_HIERARCHY WHERE PRED_REQUIREMENT_ID IN
	(SELECT REQUIREMENT_ID FROM INSERTED WHERE REQUIREMENT_CLASS_ID IN (SELECT REQUIREMENT_CLASS_ID FROM $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement')))
	END
GO

CREATE TRIGGER TRG_REQHIER2
    ON $(NF_SCHEMA).REQUIREMENT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
  DELETE FROM $(NF_SCHEMA).REQUIREMENT_HIERARCHY  WHERE  PRED_REQUIREMENT_ID IN
  (SELECT  REQUIREMENT_ID FROM INSERTED WHERE REQUIREMENT_CLASS_ID NOT IN (SELECT REQUIREMENT_CLASS_ID FROM $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement')))
  OR SUCC_REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED WHERE REQUIREMENT_CLASS_ID NOT IN (SELECT REQUIREMENT_CLASS_ID FROM $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement')))
 END
GO

INSERT INTO $(NF_SCHEMA).TIMESHEET (TIMESHEET_ID, REFERENCE_ID) VALUES (-1, 'Info Not Available')
GO

DROP VIEW $(STAR_SCHEMA).VW_TESTSUITELOG
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG (BUILD_ID, TESTSUITELOG_NAME,END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, TESTSUITELOG_ID, TESTSUITE_ID, TESTSUITE_NAME, URL, VERDICT,OWNER_ID, OWNER_NAME,TESTPLAN_ID,TESTPLAN_NAME,WEIGHT,POINTS_PASSED,POINTS_FAILED,POINTS_BLOCKED,POINTS_INCONCLUSIVE,POINTS_ATTEMPTED,POINTS_PERMFAILED,POINTS_DEFERRED,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITELOG_CLASS_ID,TESTSUITELOG_CLASS_NAME,TESTSUITE_EXECRECORD_ID,TESTSUITE_EXECRECORD_NAME,REC_DATETIME,ISSOFTDELETED,
TESTSUITELOG_STATE,TESTSUITELOG_STATE_ID,TESTSUITELOG_STATE_EXTERNAL_ID,TESTSUITELG_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,TOTAL_TESTCASE_COUNT,NOTSTARTED_TESTCASE_COUNT) AS
 (SELECT S.BUILD_ID, S.NAME AS TESTSUITELOG_NAME, S.END_DATE, S.EXTERNAL_ID, S.ITERATION_ID,I.NAME AS ITERATION_NAME, S.REFERENCE_ID, S.START_DATE, S.TESTSUITELOG_ID, S.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, S.URL, S.VERDICT,S.OWNER_ID,R.FULL_NAME AS  OWNER_NAME ,S.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,S.WEIGHT,S.POINTS_PASSED,S.POINTS_FAILED,S.POINTS_BLOCKED,S.POINTS_INCONCLUSIVE,S.POINTS_ATTEMPTED,S.POINTS_PERMFAILED,S.POINTS_DEFERRED,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.TESTSUITELOG_CLASS_ID,TL.NAME AS TESTSUITELOG_CLASS_NAME,S.TESTSUITE_EXECRECORD_ID,TEX.NAME AS TESTSUITE_EXECRECORD_NAME,S.REC_DATETIME,S.ISSOFTDELETED,
 TS.NAME AS TESTSUITELOG_STATE,S.TESTSUITELOG_STATE_ID,TS.EXTERNAL_ID AS TESTSUITELOG_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITELG_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,S.TOTAL_TESTCASE_COUNT,S.NOTSTARTED_TESTCASE_COUNT
 FROM $(NF_SCHEMA).TESTSUITELOG S
 JOIN $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=S.ITERATION_ID
 JOIN $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=S.TESTSUITE_ID
 JOIN $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=S.OWNER_ID
 JOIN $(NF_SCHEMA).TESTSUITELOG_CLASSIFICATION TL ON TL.TESTSUITELOG_CLASS_ID=S.TESTSUITELOG_CLASS_ID
 JOIN $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=S.TESTPLAN_ID
 JOIN $(NF_SCHEMA).TESTSUITE_EXECUTION_RECORD TEX ON TEX.TESTSUITE_EXECRECORD_ID=S.TESTSUITE_EXECRECORD_ID
 JOIN $(NF_SCHEMA).TESTSUITELOG_STATE TS ON TS.TESTSUITELOG_STATE_ID=S.TESTSUITELOG_STATE_ID
JOIN $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO
GRANT SELECT ON $(STAR_SCHEMA).VW_TESTSUITELOG TO REPUSER
GO

CREATE INDEX DT_DOMIDX ON $(STAR_SCHEMA).D_DATE (DAY_OF_MONTH ASC) ON  VSTR_IDX
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=6
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET CHAR_VALUE='2.0.3 RC2',INT_VALUE=9 WHERE INFO_ID=18
GO
