
SET CURRENT SCHEMA $CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=7;

INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=8);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,11 AS INT_VALUE,'2.0.3 RC1' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=18);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME  from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=9);

CREATE INDEX $NF_SCHEMA.TIMESHEET_IDX7 ON $NF_SCHEMA.TIMESHEET (TIMESHEET_REPORTING_WEEK, ACTIVITY_ID, REFERENCE_ID);

DROP TRIGGER $NF_SCHEMA.TRG_REQREQUI2;
CREATE TRIGGER $NF_SCHEMA.TRG_REQREQUI2
	AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.REQUIREMENT
	REFERENCING NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
	DELETE FROM $NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP WHERE REQUIREMENT_ID=NEWROW.REQUIREMENT_ID AND
	NEWROW.REQUIREMENT_CLASS_ID IN (SELECT REQUIREMENT_CLASS_ID FROM $NF_SCHEMA.REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement'));

DROP TRIGGER $NF_SCHEMA.TRG_TPTPHIER;
CREATE TRIGGER $NF_SCHEMA.TRG_TPTPHIER
	AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.TESTPLAN
	REFERENCING NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
	DELETE FROM $NF_SCHEMA.TESTPLAN_TESTPLAN_HIERARCHY
	WHERE NEWROW.TESTPLAN_CLASS_ID <>(SELECT TESTPLAN_CLASS_ID FROM $NF_SCHEMA.TESTPLAN_CLASSIFICATION WHERE NAME ='RQM Test Plan')
	AND (PARENT_TESTPLAN_ID=NEWROW.TESTPLAN_ID OR CHILD_TESTPLAN_ID=NEWROW.TESTPLAN_ID);

CREATE TRIGGER $NF_SCHEMA.TRG_TPTPHIER2
	AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.TESTPLAN
	REFERENCING NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
	DELETE FROM $NF_SCHEMA.TESTPLAN_TESTPLAN_HIERARCHY
	WHERE NEWROW.TESTPLAN_CLASS_ID =(SELECT TESTPLAN_CLASS_ID FROM $NF_SCHEMA.TESTPLAN_CLASSIFICATION WHERE NAME ='RQM Test Plan')
	AND PARENT_TESTPLAN_ID=NEWROW.TESTPLAN_ID;
	
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=6;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.3 RC1',INT_VALUE=11 WHERE INFO_ID=18;