INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=6)
GO
INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=7)
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=7
GO

IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=8) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MIGRATION_STATUS',DISPLAY_NAME='Insight Warehouse Migration Status',INT_VALUE=0,CHAR_VALUE='' WHERE INFO_ID=8
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=18) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,11 AS INT_VALUE,'2.0.3 RC1' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MINOR_VERSION',DISPLAY_NAME='Insight Warehouse Minor Version',INT_VALUE=11,CHAR_VALUE='2.0.3 RC1' WHERE INFO_ID=18
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=9) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='DATA_TRUNCATION',DISPLAY_NAME='Interpreted as do not compute or delete data with dates earlier or equal to the value set' ,INT_VALUE=1 WHERE INFO_ID=9
GO

CREATE INDEX TIMESHEET_IDX7 ON $(NF_SCHEMA).TIMESHEET (TIMESHEET_REPORTING_WEEK, ACTIVITY_ID, REFERENCE_ID) ON VNF_IDX
GO

DROP TRIGGER $(NF_SCHEMA).TRG_REQREQUI2
GO
CREATE TRIGGER TRG_REQREQUI2
    ON $(NF_SCHEMA).REQUIREMENT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
 DELETE FROM $(NF_SCHEMA).REQUIREMENT_REQUEST_LOOKUP  WHERE  REQUIREMENT_ID IN
  (SELECT  REQUIREMENT_ID FROM INSERTED WHERE REQUIREMENT_CLASS_ID IN (SELECT REQUIREMENT_CLASS_ID FROM $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION WHERE NAME IN ('RRC Requirement','Doors Requirement')))
 END
GO

DROP TRIGGER $(NF_SCHEMA).TRG_TPTPHIER
GO

CREATE TRIGGER TRG_TPTPHIER
	ON $(NF_SCHEMA).TESTPLAN

	FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
    DECLARE @cls int
	SELECT @cls=TESTPLAN_CLASS_ID FROM $(NF_SCHEMA).TESTPLAN_CLASSIFICATION WHERE NAME='RQM Test Plan'
	BEGIN

		DELETE FROM $(NF_SCHEMA).TESTPLAN_TESTPLAN_HIERARCHY
		WHERE @cls NOT IN (SELECT TESTPLAN_CLASS_ID FROM INSERTED)
		AND (PARENT_TESTPLAN_ID IN (SELECT TESTPLAN_ID FROM INSERTED) OR CHILD_TESTPLAN_ID IN (SELECT TESTPLAN_ID FROM INSERTED))
	 END
END
GO

CREATE TRIGGER TRG_TPTPHIER2
	ON $(NF_SCHEMA).TESTPLAN

	FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
    DECLARE @cls int
	SELECT @cls=TESTPLAN_CLASS_ID FROM $(NF_SCHEMA).TESTPLAN_CLASSIFICATION WHERE NAME='RQM Test Plan'
	BEGIN

		DELETE FROM $(NF_SCHEMA).TESTPLAN_TESTPLAN_HIERARCHY
		WHERE @cls IN (SELECT TESTPLAN_CLASS_ID FROM INSERTED)
		AND PARENT_TESTPLAN_ID IN (SELECT TESTPLAN_ID FROM INSERTED)
	 END
END
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=6
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET CHAR_VALUE='2.0.3 RC1',INT_VALUE=11 WHERE INFO_ID=18
GO