/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.dashboard.web.ui.ProjectDashboard");

dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.dashboard.web.ui.ProcessAreaDashboard");

var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
var ProcessAreaDashboard = com.ibm.team.dashboard.web.ui.ProcessAreaDashboard;

/**
 * A project dashboard. Provides API and behavior specific to project dashboards, including
 * toolbar actions, auto-save behavior, and project details.
 * 
 * @since 4.0.1
 */
dojo.declare("com.ibm.team.dashboard.web.ui.ProjectDashboard", [ProcessAreaDashboard], {
	
	/**
	 * (Optional)
	 * The name of the project whose dashboard to show. The project is assumed to reside
	 * on the current server hosting the Web UI. This is an alternative to using the
	 * url parameter in the Dashboard base class for project dashboards.
	 * 
	 * @type string
	 */
	projectName: null,
	
	// internal
	iconUrl: dojo.moduleUrl("com.ibm.team.dashboard.web", "graphics/Dashboard/icons/proj-dash_obj.gif").toString(),
	scope: DashboardConstants.SCOPE_PROJECT_AREA,
	
	constructor: function(args) {
		this.projectArea = args.projectName;
	}
});

})();
