/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.jfs.web.ui.internal.JTSWelcomeViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("dojo.i18n");
dojo.require("jazz.util.i18n");

dojo.requireLocalization("com.ibm.team.jfs.web.ui.internal", "JTSWelcomeViewletMessages");

(function() {

/*
 * The Jazz Team Server welcome viewlet.
 */
dojo.declare("com.ibm.team.jfs.web.ui.internal.JTSWelcomeViewlet", com.ibm.team.dashboard.web.ui.Viewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.team.jfs.web", "ui/internal/templates/JTSWelcomeViewlet.html"),
	messages: dojo.i18n.getLocalization("com.ibm.team.jfs.web.ui.internal", "JTSWelcomeViewletMessages"),
	
	buildRendering: function(){
		this.inherited(arguments);
		
		// populate the text and link
		var nodes = jazz.util.i18n.addMessage(this.text, this.messages.welcomeText);
		nodes[0].href = "#action=com.ibm.team.app.viewWelcome";
		
		nodes = jazz.util.i18n.addMessage(this.text2, this.messages.welcomeText2);
		nodes[0].href = "http://jazz.net/library/video/494";
		nodes[0].target = "_top";
	}
});
})();