/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.ui.internal.about.AboutDialog");	

dojo.require("jazz.ui.Dialog");
dojo.require("dojo.i18n");
dojo.require("jazz.core.loader");
dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.about", "AboutDialogMessages");

var messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.about", "AboutDialogMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.repository.web.ui.internal.about.AboutDialog", [jazz.ui.Dialog], {
	width: "800px",
	height: "400px",
	destroyContents: true,
	closeOnBlur: true,
	postCreate: function() {
		this.contentNode = dojo.create("div", {innerHTML: messages.loading, "class": "j-hint", style: "padding: 10px"});
		this.inherited(arguments);
		
		// lazy load the about box content
		jazz.core.loader.load_async("com.ibm.team.repository.web.ui.internal.about.AboutJazzTeamServer", dojo.hitch(this, function() {
			var aboutContent = new com.ibm.team.repository.web.ui.internal.about.AboutJazzTeamServer({
				onReload: dojo.hitch(this, this.updatePosition)
			}).placeAt(this.contentNode, "replace");
			this.contentNode = aboutContent.domNode;
			this.height = "";
			this.setHeight();
		}));
	}
});
})();