/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ExportTemplateFromProjectDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.common.internal.ProcessUtils"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._TemplatedMixin"); //$NON-NLS-1$
dojo.require("dijit._WidgetsInTemplateMixin"); //$NON-NLS-1$
dojo.require("dijit.form.Button"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("dojox.uuid"); //$NON-NLS-1$
dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "ExportTemplateFromProjectDialogMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
var ProcessUtils = com.ibm.team.process.web.common.internal.ProcessUtils;
var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
var SERVICE_URI = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/";//$NON-NLS-1$
var EXPORT_PREPARATION_STATUS_SERVICE_URL = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/checkExportPreparationProgress";//$NON-NLS-1$
(function(){

	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ExportTemplateFromProjectDialog", [dijit._Widget, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/ExportTemplateFromProjectDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function(args){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "ExportTemplateFromProjectDialogMessages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.projectAreaName = args.name;
			this.projectAreaId = args.itemId;
			this.projectAreaSummary = args.summary;
		},
		
		postCreate: function(){
			var args = {};
			args.projectAreaItemId = this.projectAreaId;
			var details = dojo.string.substitute(this.messages.ExportTemplateFromProjectHTML_Details, [this.projectAreaName]);
			this._details.innerHTML = details;
			this.connect(this.templateName, "onkeyup", "_enableOkButton"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.templateName, "onchange", "_enableOkButton"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.templateId, "onkeyup", "_enableOkButton"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.templateId, "onchange", "_enableOkButton"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this._okButton, "onclick", this._ok); //$NON-NLS-1$
			this.connect(this._cancelButton, "onclick", function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this._cancel();
			});
			if (dojo.isIE) {
				this.templateSummary.rows = 4;
			}
			
			this.dialog = new jazz.ui.Dialog({
				primaryTitle: this.messages.ExportTemplateFromProject_PrimaryTitle,
				contentNode: this.domNode,
				width: "40em", //$NON-NLS-1$
				destroyContents: true,
				onClose: dojo.hitch(this, function(){
					this._onCloseDialog();
				})
			});
			
			if (this.projectAreaName) {
				this.templateName.value = this.projectAreaName;
			}
			
			if (this.projectAreaSummary) {
				this.templateSummary.value = this.projectAreaSummary;
			}
			
			this.templateName.focus();
			
		},
		
		startup: function(){
			UIHelper.resizeI18NButtons(this.dialogFooter, [this._okButton, this._cancelButton]);
			this.inherited(arguments);
		},
		
		_ok: function(){
			this._disableEditing(true);
			var data = this._constructPostData();
			dojo.removeClass(this._messageBox.domNode, "hidden"); //$NON-NLS-1$
			dojo.addClass(this._details, "hidden"); //$NON-NLS-1$
			this._messageBox.showMessage({
				summary: this.messages.ExportTemplateFromProject_ExportInProgress
			});
			this.processExportKey = dojox.uuid.generateTimeBasedUuid();
			var deferred = jazz.client.rawXhrPost({
				url: SERVICE_URI + "?isFromProject=true&exportKey=" + this.processExportKey, //$NON-NLS-1$
				handleAs: "text", //$NON-NLS-1$
				contentType: "text/json; charset=utf-8", //$NON-NLS-1$
				postData: data,
				load: dojo.hitch(this, this._doExportTemplate),
				error: dojo.hitch(this, function(error){
					this._disableEditing(false);
					this._messageBox.showMessage({
						summary: this.messages.ExportTemplateFromProject_PostTemplateInfoError,
						type: jazz.ui.MessageBox.STATUS_TYPES.ERROR
					});
				})
			});
		},
		
		_cancel: function(e){
			this.dialog.close();
		},
		
		_constructPostData: function(){
			var name = this.templateName.value;
			var id = this.templateId.value;
			var summary = this.templateSummary.value;
			var obj = {};
			obj.name = name;
			obj.id = id;
			obj.summary = summary;
			return dojo.toJson(obj);
		},
		
		_doExportTemplate: function(e){
			var querystring = "itemId=" + this.projectAreaId + "&exportKey=" + this.processExportKey + "&isFromProject=true"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			var zipFileName = ProcessUtils.normalizeFileName(this.templateId.value) + ".zip"; //$NON-NLS-1$
			this.intervalId = setInterval(dojo.hitch(this, "_checkExportPreparationStatus"), 1000); //$NON-NLS-1$
			window.location = SERVICE_URI + zipFileName + "?" + querystring; //$NON-NLS-1$
		},
		
		_disableEditing: function(enabled){
			this.templateName.readOnly = enabled;
			this.templateId.readOnly = enabled;
			this.templateSummary.readOnly = enabled;
			this._okButton.disabled = enabled;
		},
		
		_checkExportPreparationStatus: function(){
			dojo.xhrGet({
				url: EXPORT_PREPARATION_STATUS_SERVICE_URL,
				handleAs: "json", //$NON-NLS-1$
				content: {
					exportKey: this.processExportKey
				},
				preventCache: true,
				load: dojo.hitch(this, function(response, ioArgs){
					if (response.status === "completed" || response.status === "error") { //$NON-NLS-1$ //$NON-NLS-2$
						clearInterval(this.intervalId);
						if (this.dialog) {
							this.dialog.close();
						}
					}
					return response;
				}),
				error: function(response, ioArgs){
					return response;
				}
			});
		},
		
		
		_enableOkButton: function(){
			if (this._isValid(this.templateName.value) && this._isValid(this.templateId.value)) {
				this._okButton.disabled = false;
			} else {
				this._okButton.disabled = true;
			}
		},
		
		_isValid: function(value){
			if (!value) {
				return false;
			}
			var value = dojo.string.trim(value);
			return value.length > 0;
		},
		
		close: function(){
			this.dialog.close();
		},
		
		//invoke before the dialog is closed
		_onCloseDialog: function(){
			if (window.stop) {
				window.stop();
			}
			
			if (this.intervalId) {
				clearInterval(this.intervalId);
			}
			
			if (this.processExportKey) {
				var zipFileName = ProcessUtils.normalizeFileName(this.templateId.value) + ".zip"; //$NON-NLS-1$
				jazz.client.xhrGet({
					url: SERVICE_URI + zipFileName + "/cancelExport", //$NON-NLS-1$
					content: {
						exportKey: this.processExportKey
					},
					handleAs: "json", //$NON-NLS-1$
					preventCache: true
				});
			}
		},
		
		uninitialize: function() {
			if (this._messageBox) {
            	this._messageBox.destroyRecursive();
            	delete this._messageBox;
            }
		}
	});
	
})();
