/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$

dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.CreateIterationsDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineTree"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineStore"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.IterationDialog"); //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit.tree.dndSource");  //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("dojox.xml.parser"); //$NON-NLS-1$

dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.TwoStateButton"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;

(function(){
	dojo.declare('com.ibm.team.process.web.ui.internal.admin.projects.timeline.tree.dndSource', dijit.tree.dndSource, { //$NON-NLS-1$
	
		betweenThreshold: 5,
		singular: true,  // Only allow single drag of items
		
		copyState: function(keyPressed) {
			return false;  // Never allow the nodes to be copied
		},
		
	    onDndDrop: function(source, nodes, copy) {
			// Workaround for https://bugs.dojotoolkit.org/ticket/17403
			// This method will be invoked even when the dnd operation happens 
			// on other tree widget. So we have to make sure the tree in dnd
			// source is the instance of TimelineTree. 
			if (!(source.tree instanceof com.ibm.team.process.web.ui.internal.admin.projects.TimelineTree)) {
				return;
			}
			
			var previousTreeNode = dijit.getEnclosingWidget(nodes[0]);	
			var previousParent = previousTreeNode.getParent().item;
			// Now move the node		
			this.inherited(arguments);
			
			
			var treeNode = dijit.getEnclosingWidget(nodes[0]);			
			source.tree.moveIteration(treeNode.item, treeNode.getParent().item, previousParent);
			
	  }
	});
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/TimelineEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function(arg){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this._connectHandles = [];
			
			//disables the create timeline button
			if (this.editor._isArchived) {
				this._createTimelineButton.setAttribute("disabled", false);  //$NON-NLS-1$
			}
			
			this._actionsBar = new jazz.ui.Toolbar();
			
			this._currentIterationButton = new jazz.ui.toolbar.Button({
				title: this.messages.TimelineEditor_SetCurrentIterationTooltip,
				imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/current_phase_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				className: "currentIterationButton", // NOTE: We set this class in order to make the button selectable in Selenium //$NON-NLS-1$
				onClick: dojo.hitch(this, this._handleSetCurrentIterationClick)
			});
			this._actionsBar.addChild(this._currentIterationButton);
			
			this._timelineButton = new jazz.ui.toolbar.Button({
				title: this.messages.TimelineEditor_SetProjectTimelineTooltip,
				imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/project_devline_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				onClick: dojo.hitch(this, this._handleSetProjectTimeLineClick)
			});
			this._actionsBar.addChild(this._timelineButton);
			
			this._showArchivedButton = new jazz.ui.toolbar.TwoStateButton({
				title: this.messages.TimelineEditor_ShowArchivedTooltip,
				imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/milestone_archived_obj.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				onClick: dojo.hitch(this, this._handleShowArchivedClick)
			});
			this._actionsBar.addChild(this._showArchivedButton);

			this.actionsBarDiv.appendChild(this._actionsBar.domNode);
						
			/*
			 This won't make it into 1.0.0.1
			 
			 this.actionsBar.addButton(this, this._handleMoveIterationClick, {
			 label: this.messages.TimelineEditor_MoveIterationTooltip,
			 imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/synced.gif") //$NON-NLS-1$ //$NON-NLS-2$
			 });
			 */
			this.refresh();
		},
		
		startup: function(){
			var buttons = [this._editPropertiesButton, this._duplicateButton, this._createTimelineButton, this._createIterationButton, this._multiActionButton];
			var width = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper.resizeI18NButtons(this.buttonColumn, buttons, undefined, 2.0);
			this.inherited(arguments);
			
			// Set the width of the button column slightly larger than the buttons themselves
			this.buttonColumn.style.width = (width + 5) + "em"; //$NON-NLS-1$
			
			if (this.isLeftToRight()) {
				this._buttonArea.style.right = "-" + (width + 6) + "em"; //$NON-NLS-1$ //$NON-NLS-2$
				this._contentArea.style.marginRight = (width + 6) + "em"; //$NON-NLS-1$
			} else {
				this._buttonArea.style.left = "-" + (width + 6) + "em"; //$NON-NLS-1$ //$NON-NLS-2$
				this._contentArea.style.marginLeft = (width + 6) + "em"; //$NON-NLS-1$
			}
		},
		
		refresh: function(){
			this._clearState();
			
			this._timelineButton.set("enabled", false); //$NON-NLS-1$
			this._currentIterationButton.set("enabled", false); //$NON-NLS-1$
			
			this._multiActionButton.disabled = true;
			this._editPropertiesButton.disabled = true;
			this._createIterationButton.disabled = true;
			
			this.editor.addSaveParticipant(this, "com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$	
			this._createTimelineTree();
		},
		
		_clearState: function(){
			this.editor.removeSaveParticipant("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$	
			this._multiActionButton.innerHTML = this.messages.TimelineEditorHTML_ArchiveButtonLabel;
			this._disconnectHandles();
			delete this._model;
			if (this._timelineTree) {
				this._timelineTree.destroyRecursive();
				delete this._timelineTree;
			}
			
		},
		
		changesPending: function(){
			return this._model.store.isDirty();
		},
		
		_doCreateTimelineTree: function() {
			var store = this.editor._getProcessAreaStore();
			if (store.isInitialized()) {
				// We need to create the tree widget after the store has been initialized.
				// Otherwise, it will cause performance problem.
				this._model = new com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel({
					store: store
				});
				
				var self = this;
				this._timelineTree = new com.ibm.team.process.web.ui.internal.admin.projects.TimelineTree({
					model: this._model,
					dndController: "com.ibm.team.process.web.ui.internal.admin.projects.timeline.tree.dndSource", //$NON-NLS-1$
					editorContext: ProcessConstants.EditorContext.PROJECT,
					showArchived: this._showArchivedButton.pressed,
					onClick: function(item, node){
						// Nothing to do yet on click
					},
					
					focusChanged: function(node){
						self._multiActionButton.disabled = false;
						if (this.isNewItem(node.item)) {
							self._multiActionButton.innerHTML = this.messages.TimelineEditorHTML_DeleteButtonLabel;
						} else if (this.isArchivedItem(node.item)) {
							self._multiActionButton.innerHTML = this.messages.TimelineEditorHTML_1;
							if (this.isAnyAncestorArchived(node.item)) { //This checks parent timeline nodes status
								self._multiActionButton.disabled = true;
							}
							if (self.editor._isArchived) { //This checks the project area status
								self._multiActionButton.disabled = true;
							}
						} else {
							self._multiActionButton.innerHTML = this.messages.TimelineEditorHTML_ArchiveButtonLabel;
						}
						self._editPropertiesButton.disabled = false;
						if (this.isArchivedItem(node.item)) {
							self._createIterationButton.disabled = true;
						} else {
							self._createIterationButton.disabled = false;
						}
						
						if (!this.model.store.isTimeline(node.item) || this.model.store.isProjectTimeline(node.item)) {
							self._timelineButton.set("enabled", false); //$NON-NLS-1$
						} else {
							self._timelineButton.set("enabled", true); //$NON-NLS-1$
						}
						if (!this.model.store.isIteration(node.item) || this.model.store.isArchivedItem(node.item)) {
							self._currentIterationButton.set("enabled", false); //$NON-NLS-1$	
						} else {
							self._currentIterationButton.set("enabled", true); //$NON-NLS-1$
							// Toggle the label of the current iteration button (set/unset) based on the selection.
							if (this.model.store.isCurrentIteration(node.item)) {
								self._currentIterationButton.set("title", this.messages.TimelineEditor_UnsetCurrentIterationTooltip); //$NON-NLS-1$
							} else {
								self._currentIterationButton.set("title", this.messages.TimelineEditor_SetCurrentIterationTooltip); //$NON-NLS-1$
							}
						}
						
					}, 
					
					moveIteration: function(iteration, newParent, previousParent) {
						this.model.store.moveIteration(iteration, newParent, previousParent);
						self.editor.setDirty(self.editor.changesPending());
					}
				});
				dojox.xml.parser.removeChildren(this.timelineTreeDiv);
				this.timelineTreeDiv.appendChild(this._timelineTree.domNode);
				
				// Force to create tree nodes. This will reduce the time of expanding a tree node for the first time. 
				this._model.refreshModel();
				
				this._stopLoading();
			} else {
				setTimeout(dojo.hitch(this, function() {
					this._doCreateTimelineTree();
				}), 100);
			}
		},
		
		_createTimelineTree: function(){
			this._startLoading();
			this._doCreateTimelineTree();
		},
		
		_startLoading: function() {
			if (this.editor.isTheActiveTab(ProcessConstants.TabEnum.TIMELINE)) {
				this.editor.startLoading(this.messages.TimelineEditor_LoadingTimelines);
			}
		},
		
		_stopLoading: function() {
			if (this.editor.isTheActiveTab(ProcessConstants.TabEnum.TIMELINE)) {
				this.editor.stopLoading();
			}
		},
		
		_handleEditPropertiesClick: function(event){
			dojo.stopEvent(event);
			var item = this._timelineTree.get("selectedItem"); //$NON-NLS-1$
			if (item !== null) {
				if (this._model.store.isTimeline(item)) {
					this._editTimeline(item);
				} else {
					this._editIteration(item);
				}
			}
			
		},
		
		_handleDuplicateClick: function(event){
			dojo.stopEvent(event);
			this.comingToAComputerNearYou();
			
		},
		
		_convertDateFormat: function(dateVar){
			if (dateVar && dateVar.toGregorian) {
				return dateVar.toGregorian();
			} else {
				return dateVar;
			}
		},
		
		_handleCreateIterationClick: function(event){
			dojo.stopEvent(event);
			
			var self = this;
			
			var dialogWidget = this._createAddIterationsDialog({
				initialName: this._computeInitialIterationName(),
				isNewTimeline: true,
				summaryText: this.messages.TimelineEditor_CreateIterationsSummaryText2,
				primaryTitle: this.messages.IterationDialog_CreateIterationsTitle,
				rootItem: this._timelineTree.get("selectedItem"), //$NON-NLS-1$
				isNewTimeline: false
			});
			
			var iterationDialog = dialogWidget.iterationsDialog;
			
			this._connectHandles.push(dojo.connect(iterationDialog.finishButton, "onclick", dialogWidget, function(e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				var rootItem = iterationDialog.getPreviewTree().model.root;
				var newIteration = self._addTimilineOrIteration(iterationDialog, rootItem);
				self.editor.setDirty(self.editor.changesPending());
				self._createIterationsDialogMemento = iterationDialog.getStoredState();
				this.close();
				if(newIteration){
					self._timelineTree.focusItem(newIteration);
				}
			}));
		},
		
		_editIteration: function(iterationToEdit){
			var store = this._timelineTree.model.store;
			var initialValues = [];
			initialValues.push(this._timelineTree.getIterationId(store.getValue(iterationToEdit, "contextId"))); //$NON-NLS-1$
			initialValues.push(store.getValue(iterationToEdit, "name")); //$NON-NLS-1$
			initialValues.push(store.getValue(iterationToEdit, "startDate")); //$NON-NLS-1$
			initialValues.push(store.getValue(iterationToEdit, "endDate")); //$NON-NLS-1$
			var dialogWidget = this._createIterationDialog({
				timelineStore: this._timelineTree.model.store,
				initialValues: initialValues,
				hasDeliverable: store.getValue(iterationToEdit, "hasDeliverable"), //$NON-NLS-1$
				iterationTypeItemId: store.getValue(iterationToEdit, "iterationTypeItemId"), //$NON-NLS-1$
				isNewIteration: false,
				primaryTitle: this.messages.IterationDialog_EditIterationTitle
			});
			var self = this;
			var iterationDialog = dialogWidget.iterationDialog;
			this._connectHandles.push(dojo.connect(iterationDialog.finishButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (iterationDialog.changesPending()) {
					self._timelineTree.updateIteration(iterationToEdit, {
						contextId: iterationDialog.identifier.get('value'), //$NON-NLS-1$
						name: iterationDialog.displayName.get('value'), //$NON-NLS-1$
						startDate: self._convertDateFormat(iterationDialog.startDate.get('value')), //$NON-NLS-1$
						endDate: self._convertDateFormat(iterationDialog.endDate.get('value')), //$NON-NLS-1$
						hasDeliverable: iterationDialog.scheduledReleaseCheckbox.checked,
						iterationTypeItemId: iterationDialog.getSelectedIterationTypeId()
					});
					self.editor.setDirty(self.editor.changesPending());
				}
				this.close();
				self._timelineTree.focusItem(iterationToEdit);
			}));
			
			if (!this._timelineTree.isNewItem(iterationToEdit)) {
				// Temporarily disabled on existing iterations until back end support
				// is added to make the changes in the config XML
				iterationDialog.identifier.set('disabled', true); //$NON-NLS-1$
				iterationDialog.displayName.focus();
			} else {
				iterationDialog.identifier.focus();
			}
		},
		
		_handleMultiActionClick: function(event){
			dojo.stopEvent(event);
			var item = this._timelineTree.getFocusedItem();
			if (item !== null) {
				if (this._timelineTree.isNewItem(item)) {
					this._handleDelete(item);
				} else if (this._timelineTree.isArchivedItem(item)) {
					this._handleUnarchive(item);
				} else {
					this._handleArchive(item);
				}
			}
		},
		
		_handleDelete: function(item){
			var message = this.messages.TimelineEditor_DeleteTimelineConfirmationMessage;
			if (this._timelineTree.model.store.isIteration(item)) {
				message = this.messages.TimelineEditor_DeleteIterationConfirmationMessage;
			}
			var question = dojo.string.substitute(message, [this._timelineTree.getLabel(item)]);
			if (confirm(question)) {
				this._timelineTree.deleteSelectedItem();
				this._multiActionButton.disabled = true;
				this._editPropertiesButton.disabled = true;
				this._createIterationButton.disabled = true;
				this._multiActionButton.blur();
			}
		},
		
		_handleUnarchive: function(item){
			this._timelineTree.unarchiveSelectedItem();
			this.editor.setDirty(this.editor.changesPending());
			this._timelineTree.focusItem(item);
		},
		
		_handleArchive: function(item){
			var message = this.messages.TimelineEditor_ArchiveTimelineConfirmationMessage;
			if (this._timelineTree.model.store.isIteration(item)) {
				message = this.messages.TimelineEditor_ArchiveIterationConfirmationMessage;
			}
			var question = dojo.string.substitute(message, [this._timelineTree.getLabel(item)]);
			if (confirm(question)) {
				this._timelineTree.lastFocused.setSelected(false);
				this._timelineTree.archiveSelectedItem();
				this.editor.setDirty(this.editor.changesPending());
				if (this._showArchivedButton.pressed) {
					this._timelineTree.focusItem(item);
				} else {
					this._clearFocus();
				}
			}
		},
		
		_handleShowArchivedClick: function(event){
			dojo.stopEvent(event);
			this._timelineTree.showArchived = this._showArchivedButton.pressed;
			this._timelineTree.update();
			if (this._timelineTree.isArchivedItemSelected()) {
				this._clearFocus();
			}
		},
		
		_clearFocus: function() {
			this._timelineTree.lastFocused.setSelected(false);
			this._timelineTree.lastFocused = null;
			this._timelineButton.set("enabled", false); //$NON-NLS-1$
			this._currentIterationButton.set("enabled", false); //$NON-NLS-1$
			this._editPropertiesButton.disabled = true;
			this._createIterationButton.disabled = true;
			this._multiActionButton.disabled = true;
			this._multiActionButton.innerHTML = this.messages.TimelineEditorHTML_ArchiveButtonLabel;
			this._multiActionButton.blur();
		},
		
		_handleSetCurrentIterationClick: function(event){
			dojo.stopEvent(event);
			var store = this._model.store;
			var iteration = this._timelineTree.getFocusedItem();
			if (iteration !== null && store.isIteration(iteration)) {
				if (store.isCurrentIteration(iteration)) {
					store.clearCurrentIteration(store.getTimelineForIteration(iteration));
				} else {
					store.setCurrentIteration(iteration);
				}
				this.editor.setDirty(this.editor.changesPending());
				this._timelineTree.focusItem(iteration);
			}
			
		},
		
		_handleSetProjectTimeLineClick: function(event){
			dojo.stopEvent(event);
			var store = this._model.store;
			var timeline = this._timelineTree.getFocusedItem();
			if (timeline !== null && store.isTimeline(timeline)) {
				store.setProjectTimeline(timeline);
				this.editor.setDirty(this.editor.changesPending());
				this._timelineTree.focusItem(timeline);
			}
		},
		
		_handleMoveIterationClick: function(event){
			dojo.stopEvent(event);
			this.comingToAComputerNearYou();
		},
		
		comingToAComputerNearYou: function(){
			alert("Coming to a computer near you summer 2009. Beat the crowds and buy your tickets now online!"); //$NON-NLS-1$
		},

		_constructItemPath: function(item) {
			var path = [];
			var parentItem = this._model.store.getParent(item);
			if (parentItem) {
				path = this._constructItemPath(parentItem);
			}
			path.push(item);
			return path;
		},
		
		_addTimilineOrIteration: function(iterationsDialog, item, targetParentItem, existingPaths) {
			var newItem = null;
			var model = iterationsDialog.getPreviewTree().model;
			var store = model.store;
			var existing = store.getValue(item, "existing");//$NON-NLS-1$
			var paths = existingPaths || [];
			if (!existing) {
				var states = iterationsDialog.getStoredState();
				var isTimeline = store.getValue(item, "isTimeline"); //$NON-NLS-1$
				var itemName = store.getValue(item, "name");//$NON-NLS-1$
				var startDate = store.getValue(item, "startDate") || null;//$NON-NLS-1$;
				if (startDate && states.startTime) {
					startDate.setHours(states.startTime.getHours());
					startDate.setMinutes(states.startTime.getMinutes());
					startDate.setSeconds(states.startTime.getSeconds());
				}
				var endDate = store.getValue(item, "endDate") || null;//$NON-NLS-1$;
				if (endDate && states.startTime) {
					endDate.setHours(states.endTime.getHours());
					endDate.setMinutes(states.endTime.getMinutes());
					endDate.setSeconds(states.endTime.getSeconds());
				}
					
				if (isTimeline) {
					var timeline = {
						id: this._computeInitialTimelineId(itemName),
						name: itemName,
						startDate: startDate,
						endDate: endDate,
						projectTimeline: store.hasAttribute(item, "projectTimeline") && store.getValue(item, "projectTimeline")//$NON-NLS-1$; //$NON-NLS-2$;
					};
					newItem = this._timelineTree.addNewTimeline(timeline, targetParentItem);
				} else { // Create iteration
					var iteration = {
						id: this._computeInitialIterationId(itemName),
						name: itemName,
						startDate: startDate,
						endDate: endDate,
						hasDeliverable: store.getValue(item, "hasDeliverable"),//$NON-NLS-1$
						iterationTypeItemId: store.getValue(item, "iterationTypeItemId") //$NON-NLS-1$
					};
					newItem = this._timelineTree.addNewIteration(iteration, targetParentItem);
				}
			}

			// Recursively process the children
			var children = store.getValues(item, "items"); //$NON-NLS-1$
			if (children.length > 0) {
				var targetParentItem = newItem;
				dojo.forEach(children, dojo.hitch(this, function(child) {
					var childItem = this._addTimilineOrIteration(iterationsDialog, child, targetParentItem, paths);
					if (!newItem) {
						newItem = childItem;
					}
				}));
			} else if (!existing){
				// No children, this is a leaf, which should be expanded in the tree
				// if this is not a pre-existing item.
				paths.push(this._constructItemPath(newItem));
			}

			if (typeof existingPaths === "undefined")//$NON-NLS-1$
				this._timelineTree.setPaths(paths);
			return newItem;
		},
		
		_handleCreateTimelineClick: function(event) {
			var self = this;
			
			var dialogWidget = this._createAddIterationsDialog({
				initialName: this._computeInitialTimelineName(),
				isNewTimeline: true,
				summaryText: this.messages.TimelineEditor_CreateIterationsSummaryText1,
				primaryTitle: this.messages.TimelineDialog_CreateTimelineTitle,
				isNewTimeline: true
			});
			
			timelineDialog = dialogWidget.iterationsDialog;
			
			this._connectHandles.push(dojo.connect(timelineDialog.finishButton, "onclick", dialogWidget, function(e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				var rootItem = timelineDialog.getPreviewTree().model.root;
				var newTimeline = self._addTimilineOrIteration(timelineDialog, rootItem);
				self.editor.setDirty(self.editor.changesPending());
				self._createIterationsDialogMemento = timelineDialog.getStoredState();
				this.close();
				self._timelineTree.focusItem(newTimeline);
			}));
		},
		
		_computeInitialTimelineId: function(proposedDefaultId) {
			var idTemplate = (proposedDefaultId) ? proposedDefaultId : this.messages.TimelineDialog_NewTimelineDefaultId;
			var initialTimelineId = idTemplate;
			var i = 0;
			var store = this._timelineTree.model.store;
			var containsTimelineId = function(initialTimelineId, items) {
				if(!initialTimelineId  || !items || items.length <= 0) {
					return false;
				}
				for(var k = 0; k < items.length; k++) {
					var id = store.getValue(items[k], "contextId"); //$NON-NLS-1$
					if(initialTimelineId === id) {
						return true;
					}
				}
				return false;
			};
			
			var fetchTimelinesComplete = function(items, request) {
				while (containsTimelineId(initialTimelineId, items)) {
					i++;
					initialTimelineId = idTemplate + " (" + i + ")";//$NON-NLS-1$//$NON-NLS-2$
				}
			};
			
			store.fetch({
				query: { parent: ProcessConstants.PermissionsScopeContext.DEV_LINES},
				queryOptions: {deep: true},
				onComplete: fetchTimelinesComplete
			});
			
			return initialTimelineId;
		},

		_computeInitialTimelineName: function() {
			var initialTimelineName = this.messages.TimelineDialog_NewTimelineDefaultName;
			var i = 0;
			var store = this._timelineTree.model.store;
			var self = this;
			var containsTimelineName = function(initialTimelineName, items) {
				if(!initialTimelineName  || !items || items.length <= 0) {
					return false;
				}
				for(var k = 0; k < items.length; k++) {
					var name = store.getValue(items[k], "name"); //$NON-NLS-1$
					if(initialTimelineName === name) {
						return true;
					}
				}
				return false;
			};
			
			var fetchTimelinesComplete = function(items, request) {
				while (containsTimelineName(initialTimelineName, items)) {
					i++;
					initialTimelineName = dojo.string.substitute(self.messages.TimelineDialog_NewTimelineDefaultName_1,[i]);
				}
			};
			
			store.fetch({
				query: { parent: ProcessConstants.PermissionsScopeContext.DEV_LINES},
				queryOptions: {deep: true},
				onComplete: fetchTimelinesComplete
			});
			
			return initialTimelineName;
		},
		
		_computeInitialIterationId: function(proposedDefaultId) {
			var idTemplate = (proposedDefaultId) ? proposedDefaultId : this.messages.IterationDialog_NewIterationDefaultId;
			var initialIterationId = idTemplate;
			var selectedItem = this._timelineTree.getFocusedItem();
			var store = this._timelineTree.model.store;
			var children = store.getValues(selectedItem, "items"); //$NON-NLS-1$
			
		    var containsIterationId = function(initialIterationId, items) {
				if(!initialIterationId  || !items || items.length <= 0) {
					return false;
				}
				for(var k = 0; k < items.length; k++) {
					var id = store.getValue(items[k], "contextId"); //$NON-NLS-1$
					var separator = ProcessConstants.PERMISSION_PATH_SEPARATOR;
					var idx = id.lastIndexOf(separator);
					if(idx > -1) {
						id = id.substring(idx + separator.length);
					}
					
					if(initialIterationId === id) {
						return true;
					}
				}
				return false;
			};
			var i = 1;
			while (containsIterationId(initialIterationId, children)) {
				initialIterationId = idTemplate + " (" + i + ")";//$NON-NLS-1$//$NON-NLS-2$
				i++;
			}
			
			return initialIterationId;
			
		},
		
		_computeInitialIterationName: function() {
			var initialIterationName = this.messages.TimelineEditor_NewIterationDefaultName;
			var selectedItem = this._timelineTree.get("selectedItem"); //$NON-NLS-1$
			var store = this._timelineTree.model.store;
			var children = store.getValues(selectedItem, "items"); //$NON-NLS-1$
		    
			var containsIterationName = function(initialIterationName, items) {
				if(!initialIterationName  || !items || items.length <= 0) {
					return false;
				}
				for(var k = 0; k < items.length; k++) {
					var name = store.getValue(items[k], "name"); //$NON-NLS-1$
									
					if(initialIterationName === name) {
						return true;
					}
				}
				return false;
			};
			var i = 1;
			while(containsIterationName(initialIterationName, children)) {
				initialIterationName = dojo.string.substitute(this.messages.TimelineEditor_NewIterationDefaultName_1,[i]);
				i++;
			}
			
			return initialIterationName;
		},
		
		_editTimeline: function(timelineToEdit){
		
			var store = this._timelineTree.model.store;
			var initialValues = [];
			initialValues.push(store.getValue(timelineToEdit, "contextId")); //$NON-NLS-1$
			initialValues.push(store.getValue(timelineToEdit, "name")); //$NON-NLS-1$
			initialValues.push(store.getValue(timelineToEdit, "startDate")); //$NON-NLS-1$
			initialValues.push(store.getValue(timelineToEdit, "endDate")); //$NON-NLS-1$
			var dialogWidget = this._createTimelineDialog({
				initialValues: initialValues,
				isProjectTimeline: store.getValue(timelineToEdit, "projectTimeline"), //$NON-NLS-1$,
				isNewTimeline: false,
				primaryTitle: this.messages.TimelineDialog_EditTimelineTitle
			});
			var self = this;
			var timelineDialog = dialogWidget.timelineDialog;
			this._connectHandles.push(dojo.connect(timelineDialog.finishButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (timelineDialog.changesPending()) {
					store.updateTimeline(timelineToEdit, {
						contextId: timelineDialog.identifier.get('value'), //$NON-NLS-1$
						name: timelineDialog.displayName.get('value'), //$NON-NLS-1$
						startDate: self._convertDateFormat(timelineDialog.startDate.get('value')), //$NON-NLS-1$
						endDate: self._convertDateFormat(timelineDialog.endDate.get('value')), //$NON-NLS-1$
						projectTimeline: timelineDialog.projectTimelineCheckBox.checked
					});
					self.editor.setDirty(self.editor.changesPending());
				}
				this.close();
				self._timelineTree.focusItem(timelineToEdit);
			}));
			
			if (!this._timelineTree.isNewItem(timelineToEdit)) {
				// Temporarily disabled on existing timelines until back end support
				// is added to make the changes in the config XML
				timelineDialog.identifier.set('disabled', true); //$NON-NLS-1$
				timelineDialog.displayName.focus();
			} else {
				timelineDialog.identifier.focus();
			}
			
			
		},
		
		_createTimelineDialog: function(dialogArgs){
			var timelineDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TimelineDialog({
				initialValues: dialogArgs.initialValues,
				isProjectTimeline: dialogArgs.isProjectTimeline,
				isNewTimeline: dialogArgs.isNewTimeline
			});
			
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: dialogArgs.primaryTitle,
				contentNode: timelineDialog.domNode,
				// IE can't auto compute the size based on the width of the children
				width: dojo.isIE ? "27em" : ProcessConstants.EMPTY, //$NON-NLS-1$
				destroyContents: true,
				onClose: function() {
					// Workitem 110877
					timelineDialog.close();
					return true;
				}
			});
			dialogWidget.timelineDialog = timelineDialog;
			timelineDialog.startup();
			this._connectHandles.push(dojo.connect(timelineDialog.cancelButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			return dialogWidget;
		},
		
		_createIterationDialog: function(dialogArgs){
			var iterationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.IterationDialog(dialogArgs);
			
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: dialogArgs.primaryTitle,
				contentNode: iterationDialog.domNode,
				// IE can't auto compute the size based on the width of the children
				width: dojo.isIE ? "27em" : ProcessConstants.EMPTY, //$NON-NLS-1$
				destroyContents: true,
				onClose: function() {
					// Workitem 110877
					iterationDialog.close();
					return true;
				}
			});
			dialogWidget.iterationDialog = iterationDialog;
			iterationDialog.startup();
			this._connectHandles.push(dojo.connect(iterationDialog.cancelButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			return dialogWidget;
		},
		
		_createAddIterationsDialog: function(dialogArgs){
			var iterationsDialog = new com.ibm.team.process.web.ui.internal.admin.projects.CreateIterationsDialog({
				initialName: dialogArgs.initialName,
				isNewTimeline: dialogArgs.isNewTimeline,
				showArchived: this._showArchivedButton.pressed,
				summaryText: dialogArgs.summaryText,
				timelineModel: this._timelineTree.model,
				rootItem: dialogArgs.rootItem,
				isNewTimeline: dialogArgs.isNewTimeline,
				storedState: this._createIterationsDialogMemento
			});
			
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: dialogArgs.primaryTitle,
				contentNode: iterationsDialog.domNode,
				width: "84%", //$NON-NLS-1$
				destroyContents: true,
				onClose: function() {
					// Workitem 110877
					iterationsDialog.close();
					return true;
				}
			});
			dialogWidget.iterationsDialog = iterationsDialog;
			this._connectHandles.push(dojo.connect(iterationsDialog.cancelButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			
			dialogWidget.updatePosition();
			
			//Let the dialog open and be centered on the screen before
			//initializing the contents. If this is not done, there can be some
			//stuttering since the CreateIterationDialog's initialization can
			//require some scrolling to reveal elements on the screen
			var animConnect = dojo.connect(dialogWidget.anim, "onEnd", function() { //$NON-NLS-1$
				iterationsDialog.init();
				dojo.disconnect(animConnect);
			});

			return dialogWidget;
		},
		
		aboutToBeSaved: function(saveObj){
			var self = this;
			var dirtyTimelines = [];
			this._model.store.fetch({
				query: {
					enabledContext: ProcessConstants.PermissionContext.DEV_LINE
				},
				queryOptions: {
					deep: true
				},
				onComplete: dojo.hitch(this._model.store, function(items){
					for (var i = 0; i < items.length; i++) {
						var item = items[i];
						if (this.isDirty(item)) {
							var dirtyTimeline = {};
							dirtyTimeline.itemId = this.getIdentity(item);
							dirtyTimeline.stateId = this.getValue(item, "stateId"); //$NON-NLS-1$
							dirtyTimeline.id = this.getValue(item, "contextId"); //$NON-NLS-1$
							dirtyTimeline.name = this.getValue(item, "name"); //$NON-NLS-1$
							if (this.hasAttribute(item, "startDate")) { //$NON-NLS-1$
								var startDate = this.getValue(item, "startDate"); //$NON-NLS-1$
								if (startDate) {
									dirtyTimeline.startDate = dojo.date.stamp.toISOString(startDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							if (this.hasAttribute(item, "endDate")) { //$NON-NLS-1$
								var endDate = this.getValue(item, "endDate"); //$NON-NLS-1$
								if (endDate) {
									dirtyTimeline.endDate = dojo.date.stamp.toISOString(endDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							dirtyTimeline.projectTimeline = this.getValue(item, "projectTimeline"); //$NON-NLS-1$
							dirtyTimeline.currentIterationItemId = this.getValue(item, "currentIterationItemId"), //$NON-NLS-1$
							dirtyTimeline.archived = this.getValue(item, "archived"); //$NON-NLS-1$
							
							dirtyTimeline.iterations =  [];
							var iterations = this.getValues(item, "items"); //$NON-NLS-1$
							dojo.forEach(iterations, function(iteration) {
								dirtyTimeline.iterations.push(this.getIdentity(iteration));
							}, this);
							dirtyTimelines.push(dojo.toJson(dirtyTimeline));
						}
					}
				})
			});
			saveObj.jsonTimelines = dirtyTimelines;
			
			var dirtyIterations = [];
			this._model.store.fetch({
				query: {
					enabledContext: ProcessConstants.PermissionContext.ITERATION
				},
				queryOptions: {
					deep: true
				},
				onComplete: dojo.hitch(this._model.store, function(items){
					for (var i = 0; i < items.length; i++) {
						var item = items[i];
						if (this.isDirty(item)) {
							var dirtyIteration = {};
							var parent = this.getParent(item);
							var timeline = this.getTimelineForIteration(item);
							dirtyIteration.itemId = this.getIdentity(item);
							dirtyIteration.stateId = this.getValue(item, "stateId"); //$NON-NLS-1$
							dirtyIteration.timelineItemId = this.getIdentity(timeline);
							dirtyIteration.timelineStateId = this.getValue(timeline, "stateId"); //$NON-NLS-1$
							dirtyIteration.parentItemId = this.getIdentity(parent);
							dirtyIteration.parentStateId = this.getValue(parent, "stateId"); //$NON-NLS-1$
							dirtyIteration.iterationTypeItemId = this.getValue(item, "iterationTypeItemId"); //$NON-NLS-1$
							dirtyIteration.id = self._timelineTree.getIterationId(this.getValue(item, "contextId")); //$NON-NLS-1$
							dirtyIteration.contextId = this.getValue(item, "contextId"); //$NON-NLS-1$
							// New items don't have an original context id only those that were loaded
							if (this.hasAttribute(item, "originalContextId")) {  //$NON-NLS-1$
								dirtyIteration.originalContextId = this.getValue(item, "originalContextId"); //$NON-NLS-1$
							} else {
								dirtyIteration.originalContextId = dirtyIteration.contextId;
							}
							dirtyIteration.name = this.getValue(item, "name"); //$NON-NLS-1$
							dirtyIteration.hasDeliverable = this.getValue(item, "hasDeliverable"); //$NON-NLS-1$
							dirtyIteration.archived = this.getValue(item, "archived"); //$NON-NLS-1$
							if (this.hasAttribute(item, "startDate")) { //$NON-NLS-1$
								var startDate = this.getValue(item, "startDate"); //$NON-NLS-1$
								if (startDate) {
									dirtyIteration.startDate = dojo.date.stamp.toISOString(startDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							if (this.hasAttribute(item, "endDate")) { //$NON-NLS-1$
								var endDate = this.getValue(item, "endDate"); //$NON-NLS-1$
								if (endDate) {
									dirtyIteration.endDate = dojo.date.stamp.toISOString(endDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							dirtyIteration.current = this.isCurrentIteration(item);
							
							dirtyIteration.iterations =  [];
							var iterations = this.getValues(item, "items"); //$NON-NLS-1$
							dojo.forEach(iterations, function(iteration) {
								dirtyIteration.iterations.push(this.getIdentity(iteration));
							}, this);
							
							dirtyIterations.push(dojo.toJson(dirtyIteration));
						}
					}
				})
			});
			saveObj.jsonIterations = dirtyIterations;
			
		},
		
		saved: function(){
			this._model.store.save();
			
		},
		
		_disconnectHandles: function(){
			dojo.forEach(this._connectHandles, function(handle){
				dojo.disconnect(handle);
			});
			this._connectHandles = [];
		},
		
		uninitialize: function(){
			this.editor.removeSaveParticipant("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$
			this._disconnectHandles();
			if (this._timelineTree) {
				this._timelineTree.destroyRecursive();
				delete this._timelineTree;
			}
			
			if (this._currentIterationButton) {
				this._currentIterationButton.destroyRecursive();
				delete this._currentIterationButton;
			}
			if (this._timelineButton) {
				this._timelineButton.destroyRecursive();
				delete this._timelineButton;
			}
			if (this._showArchivedButton) {
				this._showArchivedButton.destroyRecursive();
				delete this._showArchivedButton;
			}
			
			if (this._actionsBar) {
				this._actionsBar.destroyRecursive();
				delete this._actionsBar;
			}
			delete this.editor;
			delete this._model;
			this.inherited(arguments);
		}
	});
	
})();
