/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseReportContributor");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojox.xml.parser");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.team.repository.web.client.internal.licensing");
    dojo.require("net.jazz.ajax.contextRoot");
    dojo.require("net.jazz.ajax.ui.PlatformUI");
    dojo.require("dojo.i18n");
    
	var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var licensing = com.ibm.team.repository.web.client.internal.licensing;
    var getReportHtml = licensing.getReportHtml;
	
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseReportContributor", [dijit._Widget, dijit._Templated], {
    
        postCreate: function(){
            if (this.displayIn) {
                this.allReportsView = document.createElement("div");
                this.allReportsView.className = "allReportsView";
                this.displayIn.appendChild(this.allReportsView);
                this._createReportViews(this.allReportsView);
                dojo.toggleClass(this.allReportsView, "noDisplay", true);
            }
        },
        
        fetchAllReports: function(){
            this.clearReports();
            dojo.toggleClass(this.allReportsView, "noDisplay", false);			
            this._fetchReports();
        },
        
        clearReports: function(){
        
        },
        
        _createReportViews: function(displayIn){
        
        },
        
        _fetchReports: function(){
        
        },
        
		// 
		// Checks whether or not this contributor is valid , and that the reports 
		// can be fetched
		//		
		isValid : function(){
			
		},
        
		_invokeReport: function(args, success){
            getReportHtml(new SRH(this, success, "handleServiceError"), args);
        },
		
		//
		// Notification that a service error has occured
		//
        handleServiceError: function(errObj){
           this.handleResponseCount();
        },
        
		//
		// Notification that the licenses were loaded via the service
		//        
        handleLicenseLoad: function(licenseId, licenseInfo){            
            
        },
        		                
        _displayReportInfo: function(htmlReport, displayIn){            
            dojox.xml.parser.removeChildren(displayIn);
            var reportDiv = document.createElement("div");
            reportDiv.innerHTML = htmlReport;
            displayIn.appendChild(reportDiv);
        },
		
		_prepareReportArgs : function(reportBundle,reportPath,parmNames,parmValues,showArchived){
			return {
                    bundle: reportBundle,
                    path: reportPath,
                    parameterName: parmNames,
                    parameterValue: parmValues,
                    showArchived: showArchived,
                    urlPrefix: window.location.protocol + "//" + window.location.hostname + ":" + window.location.port + net.jazz.ajax.contextRoot() + "/"
                };
		},
    
		//
		// Notification that the reports were fetched.
		//
		onFetchComplete : function(){
			
		},
	
		// 
		// Notification that a report parameter has changed
		//
		onChange : function(){			
		},
		
		handleResponseCount : function(){
			
		}
    });
    
})();
