/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function(){

    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenEditor");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojox.xml.parser");
    dojo.require("net.jazz.ajax.core.internal.util");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.ItemList");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.util");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.TokenLicenseUploadWizard");
    dojo.require("dojo.i18n");
    dojo.require("jazz.ui.Wizard");
    dojo.require("jazz.ui.MessageBox");
    dojo.require("com.ibm.team.repository.web.client.internal.ExternalLicenseClient");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    
    dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseTokenViewMessages");
    var messages;
    var TokenLicenseUploadWizard = com.ibm.team.repository.web.ui.internal.admin.server.TokenLicenseUploadWizard;
    var Wizard = jazz.ui.Wizard;
    var MessageBox = jazz.ui.MessageBox;
    var STATUS_TYPES = MessageBox.STATUS_TYPES;
    var TokenClient = com.ibm.team.repository.web.client.internal.ExternalLicenseClient;
    var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenEditor", com.ibm.team.repository.web.ui.internal.admin.ItemList, {
    
        constructor: function(args){
            this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseTokenViewMessages");
        },
        
        postCreate: function(){
            com.ibm.team.repository.web.ui.internal.admin.server.LicenseTokenEditor.superclass.postCreate.apply(this);
            this.header = new MessageBox();
            this.headerArea.appendChild(this.header.domNode);
            this.heading.innerHTML = this.messages.editorHeading;
            var addButton = document.createElement("input");
            addButton.setAttribute("type", "submit");
            addButton.setAttribute("value", this.messages.addTokens);
            this.connect(addButton, "onclick", "_onAddTokens");
            this.newItemButtonArea.appendChild(addButton);
            dojo.subscribe("/token/changed", this, "_refresh");
            this._refresh();
        },
        
        _onAddTokens: function(){
            this.header.hideMessage();
            this.uploadWizard = new TokenLicenseUploadWizard();
        },
                
        _displayTokenServiceDetails: function(svc){
            dojox.xml.parser.removeChildren(this.tbody);
            this.setHeaderRow([this.messages.tokenId, this.messages.tokenCount, this.messages.availableTokens, ""]);
            
            if (svc.installedTokens && svc.installedTokens.length > 0) {
            
                dojo.forEach(svc.installedTokens, function(installedToken){
                    var tokenId = installedToken.tokenId;
                    var numTokens = installedToken.numTokens;
                    var availTokens = installedToken.availableTokens;
                    var del = document.createElement("img");
                    var removeIconSrc = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/users/images/remove.gif").toString();
                    del.setAttribute('src', removeIconSrc);
                    del.setAttribute('title', this.messages.removeLicenseTokens);
                    del.setAttribute('id', tokenId);
                    del.setAttribute('style', "cursor:pointer;");
                    this.connect(del, "onclick", "_removeTokenLicense");
                    var row = this.addRow(null, [tokenId, numTokens.toString(), availTokens.toString(), del]);
                }, this);
            }
            else {
                var tr = document.createElement("tr");
                var td = document.createElement("td");
                td.appendChild(document.createTextNode(this.messages.noTokens));
                td.className = "noRowsYet";
                td.colSpan = 4;
                tr.appendChild(td);
                this.tbody.appendChild(tr);
                
            }
            
        },
        
        _handleLicenseRemoved: function(){
            dojo.publish("/token/changed", [{
                event: "removed"
            }]);
            this._refresh();
        },
        
        _removeTokenLicense: function(){
			//currently disabled
        },
        
        _refresh: function(){
			//NOTE: this code is currently disabled
            //TokenClient.getJazzTokenServiceInfo(new SRH(this, "_displayTokenServiceDetails", "handleError"), false , false);
        }
        
    });
    
})();
