/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/InlineEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		title: "", //$NON-NLS-1$
		noValueIndicator: "&nbsp;", //$NON-NLS-1$
		value: "", //$NON-NLS-1$
		disabled: false,
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.connect(this.name, "onblur", function(e) { //$NON-NLS-1$
				this.onBlur(this.name.value);
				this._toggleField(ProcessAuthoringConstants.EditorMode.PREVIEW);
			});
			this.connect(this.name, "onkeypress", "_onKeyPress"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.name, "onkeyup", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.name, "onchange", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			
			this.connect(this.previewName, "onclick", function(e) { //$NON-NLS-1$
				if (!this.disabled) {
					this._toggleField(ProcessAuthoringConstants.EditorMode.EDIT);
				}
            });
			this.connect(this.previewName, "onkeypress", function(e) { //$NON-NLS-1$
				if (e.charOrCode == dojo.keys.ENTER && !this.disabled) {
					this._toggleField(ProcessAuthoringConstants.EditorMode.EDIT);
				}
            });
			this.connect(this.previewName, "onmouseover", "_onMouseOver"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.previewName, "onmouseout", "_onMouseOut"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.previewName, "onfocus", "_onMouseOver"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.previewName, "onblur", "_onMouseOut"); //$NON-NLS-1$ //$NON-NLS-2$
			
			this._toggleField(ProcessAuthoringConstants.EditorMode.PREVIEW);
		},
		
		_onKeyPress: function(e){
            if (e.altKey || e.ctrlKey) {
            	return;
            }
            if (e.charOrCode == dojo.keys.ESCAPE || e.charOrCode == dojo.keys.ENTER) {
            	dojo.stopEvent(e);
            	this._toggleField(ProcessAuthoringConstants.EditorMode.PREVIEW);
            } else {
				this._handleChange();
			}
		},
		
		_onMouseOver: function(e) {
			if (!this.disabled) {
				dojo.toggleClass(this.previewName, "hover", true); //$NON-NLS-1$
			}
        },
		
		_onMouseOut: function(e) {
			dojo.toggleClass(this.previewName, "hover", false); //$NON-NLS-1$
        },
		
		_toggleField: function(mode) {
			if (mode === ProcessAuthoringConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessAuthoringConstants.NONE;
				dojo.empty(this.previewName);
				this.previewName.appendChild(document.createTextNode(this.value || this.noValueIndicator));
				this.previewName.style.display = ProcessAuthoringConstants.EMPTY;
			} else if (mode === ProcessAuthoringConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessAuthoringConstants.NONE;
				this.name.value = this.value;
				this.name.style.display = ProcessAuthoringConstants.EMPTY;
				this.name.focus();
				this.name.select();
			}
		},
		
		_handleChange: function() {
			this.value = this.name.value;
			this.onChange(this.value);
		},
		
		_setValueAttr: function(value){
			this.value = this.name.value = dojo.trim(value);
			value = value.replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;").replace(/\"/gm, "&quot;").replace(/\n/g, "<br>"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
			this.previewName.innerHTML = value || this.noValueIndicator;
		},
		
		_setDisabledAttr: function(disabled){
			if (disabled === true) {
				this.disabled = true;
				this._toggleField(ProcessAuthoringConstants.EditorMode.PREVIEW);
				dojo.toggleClass(this.domNode, "com-ibm-team-process-authoring-inlineView", true); //$NON-NLS-1$
			} else {
				this.disabled = false;
				dojo.toggleClass(this.domNode, "com-ibm-team-process-authoring-inlineView", false); //$NON-NLS-1$
			}
		},
		
		edit: function() {
			this._toggleField(ProcessAuthoringConstants.EditorMode.EDIT);
		},
		
		onChange: function(value) {
			
		},
		
		onBlur: function(value) {
			
		},
		
		uninitialize: function() {
		}
	});
})();
