/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	
	// Operational Error Messages
	
	'msgReportLoadingFailed': "CRRDV0015E The report query results cannot be displayed.",
	'msgReportLoadingFailed_explanation': "The server encountered an unexpected error that prevented it from retrieving the report query results.",
	'msgReportLoadingFailed_useraction': "To find more details about this issue, open the JavaScript console of your browser by pressing F12, refresh the widget, and check the JavaScript console for any resulting errors.",
	// Last UA edit: 2/24/2012

	'msgReportNotDeployed': "CRRDV0016W The '${0}' report resource with ID '${1}' is not deployed to the project area '${2}' on the server.",
	'msgReportNotDeployed_explanation': "The report resource is required to save report queries and render results.",
	'msgReportNotDeployed_useraction': "Ask an administrator for the project area to deploy the report resource to the project area on the server.",
	// Last UA edit: 2/24/2012

	'msgReportNotDeployed2': "CRRDV0017W The '${0}' report resource with ID '${1}' is not deployed to the selected project area on the server.",
	'msgReportNotDeployed2_explanation': "The report resource is required to save report queries and render results.",
	'msgReportNotDeployed2_useraction': "Ask an administrator for the project area to deploy the report resource to the project area on the server.",
	// Last UA edit: 2/24/2012

	'msgReadPermissionError': "CRRDV0014E The report query results cannot be shown because permission to read the report query is missing.",
	'msgReadPermissionError_explanation': "The server cannot retrieve the report query due to insufficient privileges (HTTP Status Code: 403).",
	'msgReadPermissionError_useraction': "Contact an administrator for the project area that contains the report query, and request read access to the query.",
	// Last UA edit: 2/24/2012

	'msgWhitelistError': "CRRDV0020E The report query results cannot be displayed.",
	'msgWhitelistError_explanation': "The server encountered an unexpected error that prevented it from retrieving the list of project areas that contain the report resource.",
	'msgWhitelistError_useraction': "To find more details about this issue, open the JavaScript console of your browser by pressing F12, refresh the widget, and check the JavaScript console for any resulting errors.",
	// Last UA edit: 2/24/2012

	'msgQueryMismatchError': "CRRDV0012E The report query cannot be saved.",
	'msgQueryMismatchError_explanation': "The new report query ID does not match the old report report query ID.",
	'msgQueryMismatchError_useraction': "Refresh the browser by pressing F5 and try to save the report query again.",
	// Last UA edit: 2/24/2012

	// Operational Error Messages - Parameter Panel Messages
	
	'msgReportParamMissing': "CRRDV0018E The report parameter '${0}' is missing.",
	'msgReportParamMissing_explanation': "The report parameter is required to save report queries and render results.",
	'msgReportParamMissing_useraction': "Specify a valid value for the report parameter.",
	// Last UA edit: 2/24/2012

	'msgNoParametersSelected': "CRRDV0011E No report parameters were specified.",
	'msgNoParametersSelected_explanation': "Report parameters are required to save report queries and render results.",
	'msgNoParametersSelected_useraction': "Specify valid values for all report parameters.",
	// Last UA edit: 2/24/2012

	'msgReportParameterLoadingFailed': "CRRDV0019E The report parameters cannot be displayed.",
	'msgReportParameterLoadingFailed_explanation': "The server encountered an unexpected error that prevented it from retrieving the report parameters.",
	'msgReportParameterLoadingFailed_useraction': "To find more details about this issue, open the JavaScript console of your browser by pressing F12, reopen the report parameter dialog, and check the JavaScript console for any resulting errors.",
	// Last UA edit: 2/24/2012

	'msgQuerySaveFailed': "CRRDV0013E The report query cannot be saved.",
	'msgQuerySaveFailed_explanation': "The server encountered an unexpected error that prevented it from saving the report query.",
	'msgQuerySaveFailed_useraction': "To find more details about this issue, open the JavaScript console of your browser by pressing F12, resave the report query, and check the JavaScript console for any resulting errors.",
	// Last UA edit: 2/24/2012

	'msgInvalidQueryUUID': "CRRDV0010E The report query is invalid.",
	'msgInvalidQueryUUID_explanation': "The report query ID is not a valid universally unique identifier (UUID).",
	'msgInvalidQueryUUID_useraction': "Try reselecting the report parameters and resaving the report query.",
	// Last UA edit: 2/24/2012

	// General Error Messages
	
	'msgError': "[Error] ${0}",
	'msgWarning': "[Warning] ${0}",
	'msgUnconfiguredReport': "This report is not configured.",
	'msgPreferenceLoadingFailure': "[Loading Failed]",
	'msgPreferenceFailure': "Preference loading failed",
	'msgSelectProjectAreaFirst': "Please select a project first",
	'msgNoReportsDeployed': "No report resources deployed",
	
	// Actionable Status Messages
	
	'msgActionConfigureReport': "Click <0>here</0> to configure this report.",
	'msgActionReportNotDeployed': "The '${0}' report resource with ID '${1}' is not deployed to project area '${2}'. Please contact your Jazz administrator to deploy the corresponding report resource to the project area. Otherwise, click <0>here</0> to select a different project area.",

	// General Status Messages
	
	'msgAll': "All",
	'msgYes': "Yes",
	'msgNo': "No",
	'msgMyTeamAreas': "My Team Areas",
	'msgCurrentIteration': "Current Iteration",
	'msgLoading': "Loading...",
	'msgProjectArea': "Project Area",
	'msgUndefined': "Undefined",
	'msgNoSelection': "No Selection",
	'msgUnassigned': "Unassigned",
	
	// General Names
	
	'msgMicro': "Micro",
	
	// Parameters Control Area
	
	'msgShowParameters': "Show Parameters",
	'msgHideParameters': "Hide Parameters",
	
	// Parameter Panel Messages
	
	'msgOK': "OK",
	'msgCancel': "Cancel",
	'msgPreview': "Preview",
	'msgPreviewLabel': "Preview:",
	'msgSelectProject': "Please select a project first.",
	'msgSelectReport': "Please select a report first.",
	'msgNoQuerySpecified': "No query selected"
	
})
