/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	//template
	'step2Label': "Step 2:",
	'step2Title': "Configure Jazz Team Server to use an LDAP server to act as my user registry",
	'description': "Once you have configured your application server and LDAP server as described in the server setup guide, complete this form to configure the Jazz Team Server to use your LDAP server for user and group information.",
	'helpLink': "For additional reference and help browsing your directory, see the topic ${0}How to verify LDAP parameters for Jazz Team server configuration${1}.",
	'userDescription': "Specify the following properties to configure Jazz Team Server to map to users in the LDAP server.",
	'groupDescription': "Specify the following properties to configure Jazz Team Server to map to groups in the LDAP server.",
	'computeDescription': "Based on the configuration values provided above, we can compute the remaining LDAP queries.  It is recommended that you select the option below to compute the additional queries.  You can view and modify the computed settings at any time from the Admin Configuration UI.",
	'computeLabel': "Compute and save additional LDAP queries based on these configuration values",

	'restoreLabel': "Restore to Saved",
	'testConnectionLabel': "Test Connection",
	'validateUserLabel': "Validate User",
	'saveTomcatConfigLabel': "Save Tomcat Config Files",

	//widget

	'loading': "Loading LDAP settings...",  
	'testing': "Testing the connection to the LDAP server...",  
	'pendingOk': "The configuration has pending changes.  Please test the connection to continue.",  
	'pendingErr': "Some property values are invalid.  Please correct flagged properties to continue.", 
	'pendingWarn': "Please verify properties flagged with warnings.  Test the connection to continue.", 
	'connectedOk': "LDAP connection is established.  Click Next to continue.",
	
	'connectedErr': "CRJAZ1558E The test of the LDAP connection failed.",
	'connectedErr.explanation': "When the LDAP connection was tested, errors occurred and the test failed. More details about the errors are provided.",
	'connectedErr.useraction': "Review the details to learn about the errors. Verify the LDAP configuration and retest the connection.",
	//Last revision:  01/25/2013
	
	'connectedWarn': "CRJAZ1559W An LDAP connection was established but generated warnings. Resolve the warnings or click Next to continue.", 
	'connectedWarn.explanation': "Warnings were generated during the LDAP connection. More details about the warnings are provided.",
	'connectedWarn.useraction': "Expand the details to learn about the warnings. Resolve the warnings or click Next to continue.",
	//Last revision:  01/25/2013
	
	'userOk': "User was validated correctly. Click Next to continue.",
	'userErr': "CRJAZ1851E User wasn't found in the LDAP directory.",
	'saveErr': "CRJAZ1561E An error occurred while saving the configuration properties.",
	
	'connectionError': "CRJAZ1560E An error occurred while fetching connection status.",
	'tomcatConfCreated': "The new configuration files were saved in the tomcat folder. <strong>Click \"Next\" to save the LDAP settings.</strong> Replace server.xml and web.xml with the new files and restart Tomcat.",
	
		
	//dialog
	'validateUserDescription': "Enter a user ID to validate that the user can log in with administrative privileges after the configuration is finished.",
	'labelUserId': "User ID",
	'labelOk': "OK",
	'labelSkip': "Skip",
	'dialogTitle': "Validate LDAP User"
})	



