/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	//template

	'wizardPageHeading': "Setup User Registry",
	'pleaseNote': "Please Note:",
	'restrictedLdapSync': "This server license does not support the use of a LDAP server as a User Registry for import and synchronization. To enable LDAP as a user registry, obtain a server that supports this feature. See ${0} for a list of servers.",
	'supportedLdapAuth': "This server does support the use of a LDAP server for authentication. To enable this, configure the Application Server.",
	'step1Label': "Step 1:",
	'step1Title': "Select the type of user registry you will use",
	'typeLabel': "User Registry Type",
	'descriptionLabel': "Description",
	'tomcatLabel': "Tomcat User Database",
	'tomcatDescription': "This is the simplest configuration option and allows the Jazz Team Server to manage users and groups for you with the Tomcat user database.",
	'ldapLabel': "LDAP",
	'ldapDescription': "If your organization uses LDAP to centrally manage users and groups and you have configured your application server and LDAP server as described in the server setup guide, choose this option and the Jazz Team Server will use your LDAP server for user and group information.",
	'unknownLabel': "Non-LDAP External Registry",
	'unknownDescription': "If you wish to use an external registry other than LDAP, choose this option. Note that if you choose this option you must manually create users in the Jazz Repository to correspond to the users in your external registry.",

	// widget

	'reviewAdminLink': "Review the ${0}License Key Management${1} page of the Admin UI for more information.",
	'seeServerStatus': "View the ${0}Admin Server Status Summary${1} for more information.",
	'userRegistry': "Jazz Team Server relies on a ${0}user registry${1} to provide basic information about users and groups. You may choose one of these options for your user registry:",
	'errorSavingConfig': "CRJAZ1548E An error occurred while saving the configuration properties.",
	'errorLoadingUserRegistry': "CRJAZ1547E A problem occurred while loading User Registry settings.",
	'loading': "Loading User Registry settings...",
	'adminNotDisabled': "ADMIN access was not disabled.  You need to be authenticated as a user other than ADMIN to disable ADMIN access.",
	
	'adminRolesNotDisabled': "CRJAZ1542E The user roles for ADMIN could not be removed.",
	'adminRolesNotDisabled.explanation': "You are currently authenticated as the ADMIN user. The ADMIN user cannot remove ADMIN's user roles. The ADMIN user might also have limited access to the web UI.",
	'adminRolesNotDisabled.useraction': "Authenticate as a user other than ADMIN and try again to remove ADMIN's user roles.",
	//Last revision:  01/28/2013

	'clickNext': "  Click 'Next' to continue.",
	'selectClientLicense': "Select the appropriate initial Client Access License(s) to be assigned to ${0}. You can assign additional license keys in the Admin UI as needed.", // ${0} is a username
	'selectClientLicense_generic': "Select the appropriate initial Client Access License(s) to be assigned to the new administrator. You can assign additional license keys in the Admin UI as needed.",
	'noClientLicenses': "CRJAZ2378W There are no assignable license keys installed on this server. The Setup Wizard will succeed without assigning licenses to the new administrator, but you will need licenses to perform certain actions on the server. After setup is complete, consult the documentation for installing license keys. A server restart may be required after installing the license keys.",
	'seeDBConfig': "Complete the ${0}Configure Database${1} page to adjust the database settings. ",
	'mustCreateTablesFirst': "CRJAZ1550I You cannot continue the setup because the Jazz database tables have not been created. Please follow the instructions below to continue.",
	'errorFetchingLicense': "CRJAZ1546E A problem occurred while fetching license information from the repository.",
	'noLicensesEnabled': "CRJAZ1555I License assignment is not enabled at this time because there are no licenses available.",
	'noLicensesActivated': "License assignment is not enabled at this time because there are no licenses available. Use the \"Activate Trial\" link(s) below to activate licenses. Once a license is activated, you will be able to assign it.",
	'disableAdmin': "The default ADMIN user is defined in Jazz to allow you to log into a new server, configure the server, and create an initial JazzAdmins user.  For enhanced server security we recommend that you disable default ADMIN access at this time.",
	'changeAdminPasword': "If you do not disable ADMIN access, you should at least change the default ADMIN password after completing the Jazz Team Server Setup.", 
	'importUserLabel': "Importing Your New User from LDAP",
	'importUserDescription': "Completing the LDAP configuration step above will enable the Jazz Team Server Setup to automatically import your initial user.  Your application server and LDAP server should be configured before you complete this step, and you should be logged into this Setup application as a member of the JazzAdmins role from your LDAP.  When you complete this page and click on the 'Next' button, your user will be imported into the repository.  Any Client Access Licenses you select below will be assigned to your new user.", 
	'accessUserError': "CRJAZ1541E A problem occurred accessing the user data.", 
	'dbUnavailable': "The database service is not available.  Database status:", 
	'unknownError': "CRJAZ1557E An unknown error occurred.", 
	'configureDbFirstHeading': "Configure Database Connection Before Proceeding",
	'configureDbFirstDescription': "The Jazz Team Server is not able to connect to the database.  The server must establish a connection to the database before you can configure the user registry settings.", 
	'disableAdminLabel': "Disable default ADMIN access", 
	'success': "You have successfully configured the User Registry.",
	'assignLicenseHeading': "Assign Client Access Licenses", 
	'seeLog': "See the server log for details.", 
	'loginLdapImport': "You need to be authenticated as a user from LDAP to import your user and assign licenses. Ensure the application container settings are configured correctly for LDAP, restart the server, and log in with a user from the LDAP directory to continue.", 
	'newUserLookupError': "CRJAZ1554E A problem occurred looking up the new user.", 
	'savingSettings': "Saving settings...", 
	'computeQueryError': "CRJAZ1543E A problem occurred while computing LDAP queries.", 
	'newUserLoginError': "CRJAZ1553E There was an error attempting to login as the new user",
	'newUserCreateError': "CRJAZ1551E The new user could not be created. See the details for more information.",
	'newUserCreateError.explanation': "A problem occurred while trying to create the new user. The cause of the problem is provided with the message.",
	'newUserCreateError.useraction': "To determine the cause of the problem and how to fix it, see the details provided with the message. For additional help, see the help topic 'Creating users'.",
	// Last UA revision: 02/10/2012
	
	'licenseAssignError': "CRJAZ1549E There was an error assigning licenses the new user:", 
	'disableAdminError': "CRJAZ1545E There was an error disabling ADMIN access:", 
	'removeRolesError': "CRJAZ1556E There was an error removing the roles for ADMIN:", 
	'createOAuthError': "CRJAZ1544E There was an error creating the OAuth consumer key.",
	'selectRegistry': "Please select a User Registry type from the list.", 
	'invalidEmail': "Invalid e-mail address", 
	'propertyLabel': "Property",
	'valueLabel': "Value",
	'newUserCreateUnknownError': "CRJAZ1552E There was an unknown error attempting to create the new user.  Please check your server configuration.",  
	'userIdLabel': "User ID", 
	'userIdDescrption': "Your user ID (e.g. 'jsmith')",
	'nameLabel': "Name", 
	'nameDescrption': "Your full name (e.g. 'John Smith')",
	'emailLabel': "E-mail Address", 
	'emailDescrption': "Your e-mail address (e.g. 'jsmith@example.com')",	
	'passwordLabel': "Password", 
	'passwordDescrption': "Enter a secure password.",
	'passwordLabel2': "Re-type Password", 
	'passwordDescrption2': "Re-type your password to help prevent typos.",
	'passwordMismatch': "Passwords don't match",
	'licenseTypeLabel': "Client Access License Type",
	'availabilityLabel': "Available Licenses",
	'createUser': "Please complete the form to create a new user and press the 'Next' button.",
	'createAccountLabel': "Create an administrator account", 
	'createAccountDescription': "You are currently logged in as the default user (ADMIN). Please create an administrator account for yourself using the form below. When you press the \"Next\" button, the new user account will be created in the Jazz Team Server.  Your new account will have the JazzAdmins role, which will allow you to log in to the Admin UI.",
	'correctFields': "Please correct the fields below.",
	'createUserLabel': "Create an administrative user for yourself in the Jazz Team Server:",
	'createUserDescription': "Please use the form below to create a user for yourself in Jazz Team Server. Your Jazz user ID should be set to match your login ID.",
	'userExistsLabel': "Your user exists in Jazz Team Server",
	'userExistsDescrpition': "You have successfully created a new user with the JazzAdmins role.",
	'step2Label': "Step 2:",   
	'step3Label': "Step 3:",  
	'step4Label': "Step 4:",
	'none': "None",
	'licenseAssignedError': "CRJAZ1845E Although the new user was created successfully, an error occurred while trying to assign the Client Access License keys to the new user. Click \"Show Details\" to view the details of the license assignment error. Follow the instructions to fix the problem, and click \"Next\" to try again.",
	'licensesAssignedOK': "The Client Access License keys have been successfully assigned to the new user. Click \"Next\" to continue.",
	'trialDuration': "(${0} day trial)",
	'expiredTrial': "Expired Trial",
	'pendingErr': "Some property values are invalid. Please correct flagged properties to continue.",
	'usingLDAPGroups': "The user registry was manually configured to use LDAP local groups. Please click Next to continue or select a different user registry.",
	
	'licenseAssignmentStepTitle': "Assign Licenses"
})



